/**
 * Created by 欣苇 on 2014/4/23 023.
 * 基于jquery mobile widget factory而自开发的UI组件
 */
define(function(require, exports, module){
    var UI = window.UI = {};
    /**
     * iScroll for pulling data
     * @usage 使用方式与iscroll相同，但是扩展了和上拉刷新相关的新事件，取决于内容底部与屏幕底部的距离才会出发这些事件。
     * 事件说明
     * pullStart 开始往上拉
     * pull 拉动中，这个会频繁触发
     * pullDown 上拉后松开
     * pullCancel 内容底部与屏幕底部拉开距离后，往上拉未松手又把内容滑了回来，会触发此事件。
     *
        var iScroll = UI.ListView(element, options);
        iScroll.on("pullDown", function(){
            nextPage();
        });
     */
    UI.ListView = function ListView(el, options) {
        IScroll = require("iScroll");
        if ( typeof IScroll != "function" ) {
            throw new TypeError(
                    "ListView constructor depends on IScroll constructor" +
                    " and it must be probe version of iScroll (iscroll-probe.js)." +
                    "For more information you can visit http://iscrolljs.com/#iscroll-versions");
        }

        var iScroll,
            isPulled,
            options = options || {};

        Number(options.probeType||1) < 3 && (options.probeType=3);
        iScroll = new IScroll(el, options);

        el = iScroll.wrapper;
        el.addEventListener('touchmove', function (e) { e.preventDefault(); }, false);

        iScroll.on("refresh", function(){
            isPulled = void 0;
        });
        iScroll.on("scroll", function(){
            if ( this.y < (this.maxScrollY - 5) && !isPulled ) {
                isPulled = 1, this._execEvent('pullStart');
            } else if ( this.y > (this.maxScrollY + 5) && isPulled ) {
                isPulled = 0, this._execEvent('pullCancel');
            } else if ( this.y < this.maxScrollY && isPulled  ) {
                this._execEvent('pull');
            }
        });
        iScroll.on("scrollEnd", function(){
            if ( isPulled ){
                this._execEvent('pullDown');
                isPulled = void 0;
            }
        });

        return iScroll;
    }

    return UI;
})