/**
 * Created with JetBrains WebStorm.
 * User: EX-LUOYONG002
 * Date: 13-12-10
 * Time: 上午10:04
 * To change this template use File | Settings | File Templates.
 */

;(function(){

    window.App = new Object();
    /**
     * 常量定义
     */
    var ua = navigator.userAgent.toUpperCase();
    // 当前环境是否为Android平台
    App.IS_ANDROID = ua.indexOf('ANDROID') != -1;
    // 当前环境是否为IOS平台
    App.IS_IOS = ua.indexOf('IPHONE OS') != -1;
    // 当前环境是否为本地Native环境
    App.IS_NATIVE = (App.IS_ANDROID || App.IS_IOS) ? true : false;
    //判断当前环境是否为天下通
    App.IS_TXT = ua.indexOf("PATXT") != -1;


    //=======================Native 相关================================

    var callindex = 0, toString = Object.prototype.toString;
    /**
     * 调用一个Native方法
     * @param {String} name 方法名称
     */
    App.call = function(name) {
        // 获取传递给Native方法的参数
        var args = Array.prototype.slice.call(arguments, 1);
        var callback = '', item = null;

        // 遍历参数
        for(var i = 0, len = args.length; i < len; i++) {
            item = args[i];
            if(item === undefined) {
                item = '';
            }

            // 如果参数是一个Function类型, 则将Function存储到window对象, 并将函数名传递给Native
            if(toString.call(item) == '[object Function]') {
                callback = name + 'Callback' + i;

                window[callback] = item;
                item = callback;
            }
            args[i] = item;
        }

        if(App.IS_ANDROID) {// Android平台
            //android native没有写这个方法,但在2.3系统中会掉用到另外一同名方法,导致崩溃,所以跳过
            try {
                for(var i = 0, len = args.length; i < len; i++) {
                    // args[i] = '"' + args[i] + '"';
                    args[i] = '\'' + args[i] + '\'';
                }
                eval('window.android.' + name + '(' + args.join(',') + ')');
            } catch(e) {
                console.log(e)
            }
        } else if(App.IS_IOS) {// IOS平台
            if(args.length) {
                args = '|' + args.join('|');
            }
            // IOS通过location.href调用Native方法, _call变量存储一个随机数确保每次调用时URL不一致
            callindex++;
            //location.href = '#ios:' + name + args + '|' + callindex;
            try{
                var iframe = document.createElement("iframe");
                iframe.src = '#ios:' + name + args + '|' + callindex;
                iframe.style.display = "none";
                document.body.appendChild(iframe);
                iframe.parentNode.removeChild(iframe);
                iframe= null;
            }catch(e){
                location.href = '#ios:' + name + args + '|' + callindex;
            }
        }
    }

    App.getMapDetail = function(lat,lng,addr){
        if(App.IS_NATIVE){
            App.call('getMapDetail',lat,lng,addr);
            console.log("calling getMapDetail")
        }else{
            //虚拟经纬度
            var rs = '{"lat":"222", "lng":"3333"}';
        }
        console.log("getMapDetail lat:"+lat+" lng:"+lng+" addr:"+addr );
    }

    App.getConfig = function(callback){
        if(App.IS_NATIVE){
            App.call('getConfig', callback);
        }else{
            //虚拟返回手机号
            var rs = '{"CONFIG_TAG":"prd"}';
            callback(rs);
        }
    }

    /**
     * 支持任意位置h5或native界面跳转
     * @param {String} where 入口名称
     * where命名规则：Namespace/PageName
     * ZhaoPingAn/CreditCard 找平安/信用卡
     * ZhaoPingAn/eBank 找平安/我的网银
     */
    App.navigate = function(where){
        if(App.IS_NATIVE){
            App.call('navigate',where);
            console.log("call native navigate to "+where);
        }
        console.log("navigate to "+where);
    }


})();
