/**
 * Created by 欣苇 on 2015/5/12 012.
 * @requires jQuery,Events
 */
define(function (require) {
    function CashBackView(opts) {
        //this.tpl = opts.tpl;
        this.opts = opts;
        this.collection = opts.collection;
        this.parent = opts.parent;
        this.$el = $(opts.el || opts.$el);
        this.delegateEvent();
        
        this.collection.on("success", this.render, this);
        this.collection.on("error", this._error, this);
        //this.collection.fetch();
    }
    $.extend(CashBackView.prototype, Events, {
        delegateEvent: function () {
            var _this = this,
                $btnContainer = _this.opts.$pointPreview.siblings(".buttons"),
                bridge = _this.opts.PATXTJSBridge;

            //“立即开卡”按钮行为
            $btnContainer.children(".apply").tap(function () {
                bridge.navigate(_this.opts.creditCardApplyURL, function () {
                    //当WebView关闭时 do something
                });
            });

            //“立即帮卡”按钮行为
            $btnContainer.children(".bind").tap(function () {
                bridge.isFans("10008@publicservice.pingan.com.cn", function (bool) {
                    if (bool) {
                        bridge.navigate(_this.opts.creditCardBindURL, function () {
                            //当WebView关闭时 do something
                        });
                    } else {
                        alert("信用卡绑定功能与平安银行信用卡公众号关联，所以请先关注平安银行信用卡公众号，然后再试。");
                        bridge.goAttentionView("10008@publicservice.pingan.com.cn");
                    }
                });

            });

            //toggle to show or hide more than 3 items of cash back records
            var $readMoreBtn =  this.$el.children("tfoot").find("button.slide");
            this.$el.children("tfoot").click(function () {
                _this.$el.find("tbody > tr").slice(4).toggle(0);
                _this.parent.iScroll.refresh();

                $readMoreBtn.text() == $readMoreBtn.data("slidedown-text") ?
                    $readMoreBtn.text( $readMoreBtn.data("slideup-text") ) :
                    $readMoreBtn.text( $readMoreBtn.data("slidedown-text") );
            });

        },
        render: function (data) {
            console.log(data);

            var self = this,
                $pointPreview = this.opts.$pointPreview,
                totalIntegral = parseFloat( data["totalIntegral"] ),
                differenceIntegral = parseFloat( data["differenceIntegral"] ),
                cashBackRecords = data["cashBack"],
                cashBackRecordsLen = Array.isArray( cashBackRecords ) ? cashBackRecords.length : 0;

            if ( data["icarCard"] ) {
                //积分差异详情
                $pointPreview.find("tr:first-child .num").text(totalIntegral || 0);
                $pointPreview.find("tr:last-child .num").text(differenceIntegral || 0);
                $pointPreview.add($pointPreview.next(".small-text")).show().siblings(".buttons").hide();

                self.updateDate(data["updatedDate"]);
            }

            if (data["icarCard"] && cashBackRecordsLen > 0 ) {
                //准备显示返现列表
                this.$el.parent().show();

                var $tbody = this.$el.find("tbody"),
                    $trTpl = $tbody.children().first(),
                    item = [];

                $.each(cashBackRecords, function (idx, record) {
                    var $el = $trTpl.clone(), strDate = Object.keys(record)[0];
                    $el.find("td:first-child").text( strDate );
                    $el.find("td:last-child").text( record[strDate] );

                    item.push($el[0]);
                    item.length > 3 && $el.hide();
                });

                item.length < 4 && self.$el.children("tfoot").hide(0);
                $tbody.append(item);
            }

            //更新DOM后应该刷新iScroll组件的高度设定
            (data["icarCard"] || cashBackRecordsLen) && this.parent.iScroll.refresh();
        },
        toggleButtons: function (selector, bool) {
            var $pointPreview = this.opts.$pointPreview;
            
            if ( typeof selector == "boolean" ) {
                bool = selector;
                selector = "";
            }

            $pointPreview.hide().siblings(".buttons").show().children(selector || "").toggle(bool);
        },
        updateDate: function (ts) {
            var $pointPreview = this.opts.$pointPreview,
                $time = $pointPreview.next(".small-text").find("time.date"),
                threeDays = 1000*60*60*24*3;

            ts = (ts || Date.now()) - threeDays;
            $time.text( new Date(ts).format( $time.data("format") ) );
        },
        _error: function (err) {
            switch ( parseInt(err.code) ) {
                case 601:
                    this.toggleButtons(true);
                    break;
                default:
                    break;
            }
        }
    });

    function CashBackCollection(atts, opts) {
        this.url = opts.url
    }
    $.extend(CashBackCollection.prototype, Events, {
        _req: $.Deferred().resolve(),
        parse: function (data) {
            var item = []
            Object.keys(data["cashBack"]).forEach(function (element, idx) {
                var obj = {};
                obj[element] = data["cashBack"][element];
                item.push( obj );
            });
            return item;
        },
        models: [],
        fetch: function (params) {
            var self = this,
                ajaxOpts;

            params = params || {};
            if (this._req.state() == "pending") return false;
            //与服务通信按条件读取数据列表
            ajaxOpts = {
                type: "post",
                url: self.url,
                data: $.extend({}, this.params, params),
                dataType: "json",
                beforeSend: function () {
                    self.trigger("pending");
                },
                success: function (res, textStatus, jqXHR) {
                    var code = res["code"],
                        body = res["body"];
                    switch (parseInt(code)) {
                        case 200:
                            self.models = self.models.concat(self.parse(body));
                            body.updatedDate = Date.parse( jqXHR.getResponseHeader("Date") );
                            self.trigger("success", body, res);
                            break;
                        default:
                            var err = new Error("没有数据");
                            err.code = code;
                            self.trigger("error", err);
                            break;
                    }
                },
                error: function(XHR){
                    self.trigger("error", httpErrorHandle(XHR));
                },
                complete: function(){
                    self.trigger("complete");
                }
            };

            App.getCurrentUserInfo(function(res){
                if ( res.code == 200 ) {
                    ajaxOpts.data.loginsession = res["session"];
                    self._req = $.ajax(ajaxOpts);
                }
            });

            return this._req;
        }
    });

    return {
        CashBackView: CashBackView,
        CashBackCollection: CashBackCollection
    }
});