/**
 * Created by 欣苇 on 2014/4/23 023.
 * todo 关闭loading
 */
;(function($){
    var cfg = config.get();

    Array.prototype.shuffle = function shuffle(o){
        o = o || this;
        for(var j, x, i = o.length; i; j = Math.floor(Math.random() * i), x = o[--i], o[i] = o[j], o[j] = x);
        return o;
    }

    function isEmpty(value) {
        switch (true) {
            case typeof value == "number":
                return !parseFloat(value);
                break;
            case (Array.isArray(value) || typeof value == "string"):
                return value.length == 0;
                break;
            case value instanceof Object:
                return JSON.stringify(value) == "{}";
                break;
            default:
                return !value;
                break;
        }
    }
    //Geocoding 地址解析
    function GeocodingError(code, msg){
        this.code = code;
        if ( !this.STATUS[code] ) {
            switch (true) {
                case 200<code<300:
                    this.STATUS[code] = "无权限";
                    break;
                case 300<code<400:
                    this.STATUS[code] = "配额错误";
                    break;
                default:
                    this.STATUS[code] = msg;
            }
        }
        this.message = this.STATUS[code];
    }
    GeocodingError.prototype.STATUS = {
        0	:"正常",
        1	:"服务器内部错误",
        2	:"请求参数非法",
        3	:"权限校验失败",
        4	:"配额校验失败",
        5	:"ak不存在或者非法",
        101	:"服务禁用",
        102	:"不通过白名单或者安全码不对"
    };

    //定位服务
    function PositionError(code, msg) {
        this.code = code;
        this.message = msg || this.STATUS[code] || "未知错误";
        return this;
    }
    PositionError.prototype.UNSUPPORTED = 0;
    PositionError.prototype.PERMISSION_DENIED = 1;
    PositionError.prototype.POSITION_UNAVAILABLE = 2;
    PositionError.prototype.TIMEOUT = 3;
    PositionError.prototype.STATUS = {
        0	:"定位不支持",
        1	:"请允许定位请求",
        2	:"定位不可用",
        3	:"定位超时"
    };

    /**
     * approx distance between two points on earth ellipsoid计算椭圆球体两点间的距离
     * @param {Object} lat1
     * @param {Object} lng1
     * @param {Object} lat2
     * @param {Object} lng2
     */
    function getFlatternDistance(lat1,lng1,lat2,lng2){
        var getRad = function getRad(d){
            var PI = Math.PI;
            return (parseFloat(d)||0)*PI/180.0;
        };
        var EARTH_RADIUS = 6378137.0;    //单位M

        var f = getRad((lat1 + lat2)/2);
        var g = getRad((lat1 - lat2)/2);
        var l = getRad((lng1 - lng2)/2);

        var sg = Math.sin(g);
        var sl = Math.sin(l);
        var sf = Math.sin(f);

        var s,c,w,r,d,h1,h2;
        var a = EARTH_RADIUS;
        var fl = 1/298.257;

        sg = sg*sg;
        sl = sl*sl;
        sf = sf*sf;

        s = sg*(1-sl) + (1-sf)*sl;
        c = (1-sg)*(1-sl) + sf*sl;

        w = Math.atan(Math.sqrt(s/c));
        r = Math.sqrt(s*c)/w;
        d = 2*w*a;
        h1 = (3*r -1)/2/c;
        h2 = (3*r +1)/2/s;

        return d*(1 + fl*(h1*sf*(1-sg) - h2*(1-sf)*sg));
    }

    function IndexCollection(){}
    $.extend(IndexCollection.prototype, Events, {
        defaults: {
            idAttr: "id"
        },
        models: {},
        params: {
            currentPage:1,
            reqAppId: "23333",
            pageSize: 10
        },
        url: function(){ return cfg.API("queryShopList") },
        _req: $.Deferred().resolve(),
        replayXHR: $.noop(),
        fetch: function (params) {
            var self = this,
                params = params || {};

            this._req.abort && this._req.abort();
            //if (this._req.state() == "pending") return false;
            //与服务通信按条件读取数据列表
            this.trigger("pending");
            this._req = $.ajax({
                type: "post",
                url: self.url(),
                data: $.extend({}, this.params, params),
                dataType: "json",
                success: function (data, textStatus, jqXHR) {
                    var head = data["head"],
                        body = data["body"];
                    switch (parseInt(head["rspCode"])) {
                        case 0:
                            var list = body["list"];
                            //第一页数据读取十条然后打乱顺序
                            self.params.currentPage == 1
                                && self.params.favorableType == ""
                                && self.params.orderBy == 0
                                && list.shuffle();

                            $.isArray(cfg.filter) && (list = list.filter(function(item){
                                //这里要排除找到关键词的记录，如果无关键词 !false==true 会使filter返回符合true条件的记录
                                return !cfg.filter.some(function(keyword){
                                    //找到关键词会返回true
                                    return (item["desc"] + item["title"]).search(keyword) != -1;
                                });
                            }));
                            list.length > 0 ? self.trigger("success", list, body["currentPage"]) : self.trigger("error", new Error("没有数据"));
                            self.add(list);
                            break;
                        default:
                            self.trigger("error", new Error("接口响应："+ head["rspDescription"]));
                            break;
                    }
                },
                error: function(jqXHR){
                    self.trigger("error", httpErrorHandle(jqXHR));
                },
                complete: function(){
                    var ctx = this;
                    //允许请求重试一次
                    self.replayXHR = function(){
                        this.trigger("pending");
                        $.ajax(ctx);
                    };

                    self.trigger("complete");
                }
            });

            return this._req;
        },
        nextPage: function(){
            this.once("success", function(){
                this.params.currentPage++;
            });
            this.fetch({ currentPage: this.params.currentPage + 1 });
        },
        add: function(models){
            var self = this,
                key = self.defaults.idAttr;
            $.each(models, function(i, e){
                self.models[ e[key] ] = e;
            });
        },
        reset: function(){
            this.models = {};
        }
    });

    function IndexView(){
        this.$content = $(".ui-content");
        this.$select = this.$content.children(".activitySelect");
        this.$selectList = this.$select.find(".activitySelectList");
        this.$tab =  $(":jqmData(role=tabs)");
        this.$statusBarPullUp =  this.$content.children(".status-bar.pullUp");
        this.$statusBar =  this.$content.children(".status-bar.pullDown");
        this.$locatingStatus = this.$content.find("#city .cityGps > .locating.status")

        this.collection = new IndexCollection();

        this.$list = this.$content.find(".activityList");
        this.$listItemTpl = $("template#listItem");

        this.buildUI();
        this._initEvents();

        this.setLocation();
        this.load();
    }
    $.extend(IndexView.prototype, Events, {
        _pullDirection: null,
        buildUI: function(){
            var $overlay = $(".maskLayer"),
                self = this,
                iScrollOpts = {
                    click: true,  mouseWheel: true,
                    //useTransition: true,
                    //disableMouse: true, disablePointer: true,
                    bindToWrapper: true,//当嵌套使用iscroll时建议将滚动行为绑定至wrapper
                    hScrollbar: false,
                    vScrollbar: false
                    //bounceEasing: 'back'
                    //bounce: false
                },
                $select = self.$select,
                $panel = $select.find(".panel-container"),
                resetSelectOptionsHeight = function () {
                    $panel.css( "max-height",
                            $(document.body).height() - $panel.offset().top
                            - (parseInt( $.mobile.activePage.children(".ui-content").css("padding-left") ) || 0) );
                };

            //ui.tab附加遮罩层控制行为
            var lastTMS = 0;
            $.widget( "ui.tabs", $.ui.tabs, {
                _create: function(){
                    var tab = this;
                    this._super.apply(this, arguments);
                    $overlay.click(function(){
                        self.clickThrough($.mobile.activePage);
                        tab._activate();
                    });
                },
                _eventHandler: function(e){//fix click through
                    var nowTMS = e.timeStamp;

                    if ( nowTMS - lastTMS < (this.options.delayTime||350) ) return false;
                    lastTMS = nowTMS;

                    this._super.apply(this, arguments);
                },
                _toggle: function(e){
                    this.active.size() ? ( $overlay.show(), resetSelectOptionsHeight() ) : $overlay.hide();
                    this._super.apply(this, arguments);
                }
            });

            this.iScroll = new UI.ListView(document.querySelector("#index[data-role=page]"), $.extend({
                topOffset:40,//+108+6,
                disablePullBounce:["up"]
            }, iScrollOpts));

            self.$select.on( "tabscreate", function( event, ui ) {
                //放入setTimeout执行列表中的意图是等待元素渲染完，即浏览器对元素距离和尺寸计算完毕
                setTimeout(function(){
                    //惠生活首页筛选列表滚动悬浮
                    var TopDist = self.$tab.prop("offsetTop"),//增加了topOffset导致菜单悬浮出现了位置计算错误
                        $nextEl = $select.next(),
                        fixed = 0,
                        selectListiScroll;

                    self.iScroll.on("scroll", function(){
                        if ( !fixed && this.y>>0 < -TopDist ) {//上拉并大于select组件的offset top
                            $select.insertBefore( self.$content ).addClass("fixed"), fixed = 1;
                            console.debug("$select is fixed Y:",this.y>>0, " < topDist:",-TopDist)

                        } else if ( fixed && this.y>>0 > -TopDist ) {//下拉并小于select组件bottom的offset top
                            $select.insertBefore( $nextEl ).removeClass("fixed"), fixed = 0;
                            console.debug("$select is static Y:",this.y>>0, " > TopDist:",-TopDist);
                        }
                    });

                    selectListiScroll = self.selectListiScroll = new UI.ListView(
                        $panel[0],
                        $.extend({ scrollbars: true, vScrollbar:true, bounce: false }, iScrollOpts));
                    //筛选规则下拉列表滚动时禁止问影响文档主体滚动
                    $select.on( "wheel mousemove touchmove", ".panel-container", function(e){ e.stopPropagation() } );
                    $select.on( "tabsactivate", function() { selectListiScroll.refresh() });
                    selectListiScroll.on("refresh", function(){ selectListiScroll.scrollTo(0,0,0) });
                }, 0);
            } );

            // 载入城市列表
            $.getJSON("data/cities.json", function(data, statusText, jqXHR){
                var $cityTpl = self.$tab.find("div#city-list"),
                    $container = self.$tab.find("#city"),
                    $docFragment = $(document.createDocumentFragment()),
                    elements = function() {
                        var $divider = $cityTpl.children(".divider").clone(),
                            $cities = $cityTpl.children(".city").clone(),
                            $city = $cities.children("li").clone();//jq bug: cannot clone from template document fragment
                        return {
                            $divider : $divider,
                            $cities : $cities,
                            $city : $city
                        };
                    },
                    letter,
                    //letters = [];
                    $els;

                //hot city
                $els = elements();
                $.each(data["hotList"], function(idx, city){
                    var $city = $els.$city.clone();
                    $city.children(":input").val( city.name );
                    $city.append(city.name);
                    $docFragment.append( $city );
                });
                $container.append(
                    $els.$divider.clone().text( $cityTpl.data("hot-city") ),
                    $els.$cities.clone().empty().append($docFragment)
                );

                //city list
                $docFragment.empty();
                $els.$divider.removeClass( "cityHot" );
                var $cities;
                $.each(data["list"], function(idx, city){
                    if ( letter != city["letter"] ) {
                        letter = city["letter"];
                        //letters.push(letter);
                        $els.$divider = $els.$divider.clone().text( city["letter"] );
                        $cities = $els.$cities.clone().empty();
                        $docFragment.append($els.$divider, $cities);
                    }

                    var $city = $els.$city.clone();
                    $city.children(":input").val( city.name );
                    $city.append( city.name );

                    $cities && $cities.append( $city );
                });
                $container.append( $docFragment );

                //destroy variable
                $cityTpl = $els = $docFragment = null;

                //todo build link bar by words of A to Z
            })

            //lazy load
            this.iScroll.on("scroll", function() {
                $.mobile.activePage && $.mobile.activePage.trigger("lazyload");
            });
        },
        _initEvents: function(){
            var $selectList = this.$selectList,
                $select = this.$select,
                $tab = this.$tab,
                self = this,
                $form = $tab.children("form");

            $tab.tabs({
                create: function(e, ui){
                    //选择数据与tab标签同步，并关闭遮罩层
                    $select
                        .on("click", "ul.list > li", function(e){
                            e.preventDefault();
                            e.stopPropagation();// 阻止事件冒泡到iscroll wrapper导致的类似事件穿透
                            self.clickThrough(self.$list);

                            if (self.selectListiScroll && self.selectListiScroll.moved) return;

                            var $el = $(this),
                                $input = $el.children("input[type=radio]"),
                                widget = $tab.data("ui-tabs");

                            if ( !$input.prop("checked") ) {
                                $input.prop("checked", true);
                                $input.is(":not(:disabled)") && $input.trigger("change");
                            }

                            //selectList选项更新后，更新selectText
                            self.updateSelectText();

                            widget._activate();
                        });

                    //tab创建后更新selectText
                    self.updateSelectText();
                },
                activate: function(e, ui){
                    ui.newPanel.attr("id") == "city" && self.locate();//打开城市列表tab时调用定位
                }
            });

            //列表更改条件后更新列表
            $selectList.on("change", ":radio", function(e){
                var $el = $(this), urlName;

                if ( $el.attr("name") == "favorableType" ) {
                    urlName = $el.data("url-name") || "queryShopList";
                    self.collection.url = function(){ return cfg.API(urlName) }//链接切换
                }

                $el.attr("name") == "orderBy" && self.getSelected()["orderBy"] == 1 ? self.loadByLocation() : self.reload();
            });

            this.iScroll.on("pullStart", function(){
                var txt = self.$statusBarPullUp.data("release")
                self.$statusBarPullUp.text(txt);
            });
            this.iScroll.on("pullCancel", function(){
                var txt = self.$statusBarPullUp.data("ready")
                self.$statusBarPullUp.text(txt);
            });
            this.iScroll.on("pullUp", function(){
                self._pullDirection = "up";
                self.getSelected()["orderBy"] == 1 ? self.loadByLocation() : self.reload();
            });
            this.iScroll.on("pullDown", function(){
                //todo 移动至状态条底部
                //todo 无数据时不发起请求
                self._pullDirection = "down";
                self.collection.nextPage();
            });

            this.$list.on("tap", "li", function(e){
                var  $item = $(e.target).closest("li"),
                    links = self.$listItemTpl.data("links").split(",")
                sessionStorage.setItem("id", $item.data("id"));
                $.mobile.changePage(links[ $item.data("type") ]);
                e.stopPropagation();
                //e.preventDefault();
            });

            var tryAgain = {
                error: function(){ self.collection.replayXHR() },
                locateFailure: function () {
                    self.getSelected()["orderBy"] == 1 ? self.loadByLocation() : self.reload();
                }
            };
            this.$statusBar.tap(function(){
                (tryAgain[ self.$statusBar.attr("data-status") ] || $.noop)();
            });

            this.collection.on("pending", function(){
                if ( self._pullDirection == "up" ) {
                    self.$statusBarPullUp.attr("data-status", "loading");
                    self.$statusBarPullUp.text(self.$statusBarPullUp.data("loading"));

                } else {
                    this.$statusBar.attr("data-status", "loading");
                    this.statusText(this.$statusBar.data("loading"));
                }

            }, this);
            this.collection.on("success", function(){
                if ( self._pullDirection == "up" ) {
                    self.$statusBarPullUp.attr("data-status", "ready");
                    self.$statusBarPullUp.text(self.$statusBarPullUp.data("ready"));

                } else {
                    this.$statusBar.attr("data-status", "ready");
                    this.statusText(this.$statusBar.data("ready"));
                }

                this.render.apply(this, arguments);
            }, this);
            this.collection.on("error", function(){
                var txt = self.$statusBarPullUp.data("ready");
                self.$statusBarPullUp.text(txt);

                this.$statusBar.add(self.$statusBarPullUp).attr("data-status", "error");
                this.error.apply(this, arguments);
            }, this);
            this.collection.on("complete", function () {
                self._pullDirection = null;
            });
            this.collection.on("error", function () {
                self._pullDirection == "up" && self.iScroll.refresh();
            });
            this.on("locateFailure", function(err){
                self._pullDirection == "up" && self.iScroll.refresh();
                self._pullDirection = null;
            });

            // 允许用户重新尝试定位
            $selectList.on("click", "li.cityGps", function(e){
                self.$locatingStatus.is("[data-status=failure]") && self.locate();

                if (!self.$locatingStatus.is("[data-status=success]")) {
                    e.preventDefault();
                    e.stopPropagation();
                }
            });

            this.on("locating", function(){
                if ( self._pullDirection == "up" ) {
                    self.$statusBarPullUp.attr("data-status", "locating");
                    self.$statusBarPullUp.text( self.$locatingStatus.data("locating") );

                } else {
                    self.$statusBar.attr("data-status", "locating");
                    self.$statusBar.text( self.$locatingStatus.data("locating") );
                }

                self.$locatingStatus.attr("data-status", "locating");
                self.$locatingStatus.text( self.$locatingStatus.data("locating") );
                console.debug("locating in progress");
            });
            this.on("located", function(crd){
                //坐标的类型，目前支持的坐标类型包括：bd09ll（百度经纬度坐标）、gcj02ll（国测局经纬度坐标）、wgs84ll（ GPS经纬度）
                crd.coordtype = App.IS_NATIVE ? "gcj02ll" : "wgs84ll";
                // 经纬度转城市
                $.getJSON(cfg.geocoder, {
                    location: crd.latitude+","+crd.longitude,
                    coordtype: crd.coordtype,
                    ak: cfg.BMapAK,
                    output: "json"
                }, function(data){
                    if ( data.status == 0 ) {
                        crd.city = data.result.addressComponent.city.replace("市", "");
                        self.setLocation(crd);

                    } else {
                        self.trigger("locateFailure", new GeocodingError(data.status, data.msg));
                    }
                }).fail(function(jqXHR){
                    self.trigger("locateFailure", httpErrorHandle(jqXHR));
                });
            });
            this.on("locateFailure", function(err){
                self.$locatingStatus.attr("data-status", "failure");

                if ( (err instanceof PositionError) || err.constructor.name == PositionError.name ) {
                    self.$locatingStatus.text( err.message );
                    console.warn('PositionError(' + err.code + '): ' + err.message);

                } else if ( err instanceof GeocodingError ) {
                    self.$locatingStatus.text( self.$locatingStatus.data("failure") );
                    console.warn('GeocodingError(' + err.code + '): ' + err.message);
                } else {
                    self.$locatingStatus.text( self.$locatingStatus.data("failure") );
                    console.warn('Error: ' + err.message);
                }

                self.$statusBar.attr("data-status", "locateFailure");
                self.error.apply(this, arguments);
            });

            this.on("cityReset", function(lastPos){
                $.mobile.activePage[0] == $.mobile.firstPage[0]
                    && App.confirm(
                        template(self.$locatingStatus.data("confirm"), {city: lastPos.city}),
                        function(bool){
                            typeof bool == "string" && ( bool = JSON.parse(bool) );
                            if (bool){
                                self.setOrderBy(lastPos.orderBy);//默认设置为距离最近;
                                self.updateSelectText();
                                self.$locatingStatus
                                    .siblings(":radio")
                                    .prop("checked", true)
                                    .trigger("change");//触发条件change事件，调用reload
                            }
                        } );
            });

            //页面被再次切回时触发定位方法
            $(window).on("focus", function() {
                self.locate();
            });
        },
        load: function () {
            $.extend(this.collection.params, this.getSelected());
            return this.collection.fetch();
        },
        reload: function () {
            //区别出上拉下拉来决定加载体验，从UI入手，判断元素状态来区别上拉还是下拉
            var self = this,
                page = this.collection.params.currentPage;
            this.collection.params.currentPage = 1;
            self._pullDirection != "up" && this.emptyList();
            this.collection.once("error", function () {
                self._pullDirection == "up" && (self.collection.params.currentPage = page);
            });
            return this.load();
        },
        loadByLocation: function () {
            var self = this;
            self._pullDirection != "up" && this.emptyList();//todo 这里为体验加了一次emptyList的调用觉得不合理，需重构调用逻辑

            self.off("unsetLocation.pullUp").once("unsetLocation.pullUp", function(){
                if ( self.$statusBarPullUp.attr("data-status") == "locating" ) self.reload();
            });

            self.locate();
        },
        emptyList: function () {
            this.collection.params.currentPage = 1;
            this.collection.reset();
            this.$list.empty();
        },
        getSelected: function(){
            var $tab = this.$tab,
                $form = $tab.children("form");
            return $form.serializeJSON();
        },
        setLocation: function(pos){
            pos = pos || {};

            var self = this,
                store = localStorage,
                lastPos = {},
                cityName,
                distance = 0,
                $input = self.$locatingStatus.siblings(":radio");

            //从缓存中加载
            try {
                lastPos = JSON.parse( store.getItem("lastPos") ) || {};
            } catch (ex) {
                store.removeItem("lastPos");
            }

            cityName = pos.city || lastPos.city;

            if (!cityName) return this.locate();//尝试通过定位获取

            //显示定位后的文本
            self.$locatingStatus.text(self.$locatingStatus.data("text"));
            self.$locatingStatus.attr("data-status", "success");
            self.$locatingStatus.prev(".city").show().text(cityName);
            $input.val( cityName);

            //更新请求经纬度参数
            var location = $.isEmptyObject(pos) ? lastPos : pos;
            location = gcjGPS2bdGPS(location.longitude, location.latitude);
            self.collection.params.latAndLng_x = location.lng;
            self.collection.params.latAndLng_y = location.lat;

            //从缓存中读取触发更改select文本
            if ( $.isEmptyObject(pos) ) {
                lastPos.orderBy && self.setOrderBy(lastPos.orderBy);
                self.updateSelectText();
                return;
            }

            if ( self.getSelected()["orderBy"] == 1 ) {//如果orderby条件为距离最近
                distance = getFlatternDistance(lastPos.latitude, lastPos.longitude, pos.latitude, pos.longitude);
            }

            if ( pos.city != lastPos.city ) {
                //询问是否更换默认城市
                lastPos.orderBy = 1;
                lastPos.timestamp = Date.now();
                self.trigger("cityReset", $.extend({}, lastPos, pos) );

            } else if ( distance > 500 ) {//如果定位比上次距离大于500米则触发reload
                $input.trigger("change");
            } else {
                self.trigger("unsetLocation");
            }

            //城市更换和上次位置距都需要保存
            $.extend(lastPos, pos);
            store.setItem("lastPos", JSON.stringify(lastPos));
        },
        setOrderBy: function(val, trigger){
            var $input = this.$select.find("[name=orderBy][value="+ val +"]");
            $input.prop("checked", true);
            trigger && $input.closest("li").trigger("click");
        },
        // GPS定位
        locate: function(){
            var locator = App.IS_NATIVE ? App : navigator.geolocation, self = this;

            if (self._locating) return;

            this.once("locating", function () {
                self._locating = true;
            });
            this.once("locateFailure located", function () {
                self._locating = false;
            });

            this.trigger("locating");

            locator ? locator.getCurrentPosition(function(pos){
                typeof pos == "string" && (pos = JSON.parse(pos));
                self.trigger("located", pos.coords);

            },function(err){
                typeof err == "string" && (err = JSON.parse(err));
                self.trigger("locateFailure", new PositionError(err.code) );

            }, {
                //enableHighAccuracy: true,//精度要求
                //maximumAge: 0,//缓存时常
                timeout: cfg.AjaxTimeout*2
            }) : this.trigger("locateFailure", new PositionError(0));
        },
        updateSelectText: function(){
            //读取默认选择 依赖li元素tap事件绑定行为
            var widget = this.$tab.data("ui-tabs");

            this.$selectList.find(":radio:checked:first-child:not(:disabled)").each(function(i, e){
                var $input = $(this);
                widget.anchors
                    .filter("[href=#"+ $input.attr("name") +"]")
                    .children("span").text( $input.prop("nextSibling").nodeValue.trim() || $input.val() );
            });
        },

        render: function(data, page){
            //渲染数据列表
            var $items = $(),
                self = this,
                tpl = this.$listItemTpl.html().trim(),
                links = this.$listItemTpl.data("links").split(","),
                $item,
                $img;

            $.each(data, function(i, e){
                //0优惠商户 1优惠活动
                e.link = links[e.type];
                $item = $(template( tpl, e).trim());
                $item.data({
                    id: e.id,
                    type: e.type
                });
                //统计代码用的属性
                $($item).attr({
                    otype: "button",
                    otitle: [document.title, "优惠信息点击", "全部点击总数"]
                        .map(function(v){return typeof v == "string" ? v.trim() : v})
                        .join("-")
                });
                $items = $items.add( $item );
            });

            $img = $items.children("img[data-original]");
            $img.lazyload({
                effect : "fadeIn",
                event: "scroll lazyload",
                container: $.mobile.activePage
            });

            page == 1 && this.emptyList();
            this.$list.append( $items );

            this.statusText();//关闭状态文本显示

            var timeout = setTimeout(function () {
                $items.length && self.iScroll.refresh();
                $.mobile.activePage.trigger("lazyload");
                clearTimeout(timeout);
                $items = $img = null;
            }, 0);
        },
        statusText: function(message){
            message = message || "";
            message.length && this.$statusBar.show().text(message);
        },
        error: function(err){
            this.statusText(err.message + "，点击重试");

            console.debug("error has been occurred", arguments);
        },
        clickThrough: function(el){
            $(el).css("pointer-events", "none");
            setTimeout(function(){
                $(el).css("pointer-events", "auto");
            }, 500);
        }
    });

    window.App && App.IS_TXT && App.call('ProgressLoading');
    window.indexView = new IndexView;

    $("#index:jqmData(role=page)").on("pageinit", function(){

        function exesdcjs(){
            var jDomain="www.pingan.com";
            var js_path="/app_js/sdc/src/app.js";
            var domain="http"+(window.location.protocol.indexOf('https:')==0?'s':'')+"://"+jDomain;
            var SDC_js=document.createElement("script");
            SDC_js.src=domain+js_path;
            var headElem=document.getElementsByTagName("head")[0];
            headElem.appendChild(SDC_js);
        }

        setTimeout(function () {
            exesdcjs();
        },0);

    })
})(jQuery)