// 路径定义
require.config({
    baseUrl : '',
    waitSeconds: 30,
    shim : {
        'jquery' : {
            exports : '$'
        },
        'underscore' : {
            exports : '_'
        },
        'backbone' : {
            deps : ['underscore', 'jquery'],
            exports : 'Backbone'
        },
        'PAWA' : {
            deps : ['backbone'],
            exports : 'PAWA'
        },
//      'PAWAModel' : {
//          deps : ['PAWA'],
//          exports : 'PAWAModel'
//      },
//      'PAWACollection' : {
//          deps : ['PAWA'],
//          exports : 'PAWACollection'
//      },
//      'PAWAView' : {
//          deps : ['PAWA'],
//          exports : 'PAWAView'
//      },
//      'PAWARouter' : {
//          deps : ['PAWA'],
//          exports : 'PAWARouter'
//      },
//      'PAWAHistory' : {
//          deps : ['PAWA'],
//          exports : 'PAWAHistory'
//      },
//      'PAWAController' : {
//          deps : ['PAWA'],
//          exports : 'PAWAController'
//      },
//      'PAWAAll' : {
//          deps : ['PAWA', 'PAWAModel', 'PAWACollection', 'PAWAView', 'PAWARouter', 'PAWAHistory', 'PAWAController'],
//          exports : 'PAWAAll'
//      },
        logger : {
            deps : ['backbone'],
            exports : 'logger'
        },
        "lib/jquery/jquery.touch": ['jquery'],
        "jq/jquery.validate": ['jquery'],
        "lib/basic-lib.extend": ["jquery", "underscore", "backbone"],
        "commonModel/AppModel": ["backbone"]
    },
    paths : {
        text : 'assets/plugins/require/text',
        jquery : 'assets/lib/jquery/jquery-2.0.3',
        underscore : 'assets/lib/lodash-1.3.1',
        backbone : 'assets/lib/backbone/backbone',
        PAWA : 'assets/lib/PAWA/PAWA',
        PAWAModel : 'assets/lib/PAWA/PAWAModel',
        PAWACollection : 'assets/lib/PAWA/PAWACollection',
        PAWAView : 'assets/lib/PAWA/PAWAView',
        PAWARouter : 'assets/lib/PAWA/PAWARouter',
        PAWAHistory : 'assets/lib/PAWA/PAWAHistory',
        PAWAController : 'assets/lib/PAWA/PAWAController',
        PAWALoggerAdapter : 'assets/lib/PAWA/PAWALoggerAdapter',
        PAWARequest : 'assets/lib/PAWA/PAWARequest',
        //PAWAAll : 'assets/lib/PAWA/PAWAAll',
        PAWAAll : 'assets/lib/PAWA/PAWA',
        logger : 'assets/lib/logger/logger',
        // 公共模块路径
        commonController : 'app/modules/common/controller',
        commonModel : 'app/modules/common/model',
        commonView : 'app/modules/common/view',
        commonTpl : 'app/modules/common/template',
        commonUtils : 'app/modules/common/utils',
        commonUI : 'app/modules/common/ui',
        "native" :"assets/lib/native/native",
        helper: 'assets/lib/helper',
        lib:'assets/lib',
        iscroll:"assets/lib/iscroll/iscroll",
        "config":'conf/default',
        jq: "assets/lib/jquery"
    }
});

require([
    'PAWAAll'
    ,'jquery'
    ,"lib/jquery/jquery.touch"
    ,'underscore'
    ,'backbone'
    ,"lib/basic-lib.extend"
    ,'config'
    ,'helper/Support'
    ,"commonModel/AppModel"
    ,"native"
    ,"lib/adaptUILayout"
], function() {
/*	if(window.screen.width > 640){
		adaptUILayout.adapt(640);//适配宽度640
	}*/
	
    var PAGE_CreditCard='1',//信用卡
        PAGE_Securities='2',//证券
        PAGE_Health='3',//健康险
        PAGE_Property='4',//财产险
        PAGE_App='5',//应用汇
        PAGE_Bank='6',//银行
        PAGE_OldAge='7',//养老险
        PAGE_Life='8',//人寿保险
        PAGE_Car='9',//车险报案
        PAGE_Postion='10';//网点查询
    var PAGE_HASH={
        '1':'selfserver/selfserver/index/106',
        '2':'selfserver/selfserver/index/105',
        '3':'selfserver/selfserver/index/104',
        '4':"selfserver/selfserver/index/107",
        '5':'selfserver/selfserver/recommendApp',
        '6':'selfserver/selfserver/index/101',
        '7':'selfserver/selfserver/index/103',//目前使用公众平台
        '8':'selfserver/selfserver/index/102',
        '9':'chexian/chexian/index',
        '10':'home/POS/index'
    };
/*
native getStartPage 期望返回数据格式:
    {"page":"1","tel":"13512345678","lon":"114.1044","lat":"22.567"};
    */

    window.BACKBUTTON=function(){
        if(window.jQuery){jQuery(document).trigger("backbutton")}
    }
    //enhance accessibility for form
    $(document).off(".tabIndex").on("keydown.tabIndex", "form", function(e){
        //console.debug("The key code is "+ e.which);
        if (e.which == 13) {//支持使用回车键切换输入框
            e.preventDefault();

            var $form = $(this),
                elements = [],
                tabIndex,
                $next, name;

            //通过tabIndex排序元素
            if ( _.isEmpty( $form.data("eleSortByTabIdx") ) ) {
                var eleByTabIdx = [];
                $( $form.prop("elements") ).each(function(){
                    var $el = $(this);
                    if ( $el.is(":input:not(:button):visible:enabled") && $el.prop("tabIndex") > -1 ) {
                        $el.prop("tabIndex") > 0 ? eleByTabIdx.push( this ) : elements.push( this );
                    }
                });
                elements = _.sortBy(eleByTabIdx, "tabIndex").concat( elements ); eleByTabIdx = void 0;
                $form.data("eleSortByTabIdx", elements);
            } else {
                elements = $form.data("eleSortByTabIdx");
            }

            tabIndex = Math.max( $( elements ).index( e.target ), 0 ) + 1;

            $next = $( elements[ tabIndex ] );
            if ( $next.size() > 0 ) {
                name = $next.attr("name") || $next.text();
                console.debug("move on to the " + name);
                $next.focus();
                //(_.unearth("cordova.exec") || $.noop)(function(info){}, function(info){}, 'CommonTools', 'hideOr', []);
            } else {
                /*console.debug( "trigger submit event on form " + ($form.prop("id")||$form.prop("name")) );
                 e.type = "submit";
                 $form.trigger(e);*/
            }
        }
    });
    // 初始化PAWA框架
    var client = require('helper/Support'),
        initialize = function(){
            document.addEventListener("online", function(){
                navigator.onLine = true;
                console.log("device is online");
            }, false);
            document.addEventListener("offline", function(){
                navigator.onLine = false;
                console.log("device is offline");
            }, false);
            $(document).on("backbutton", function(e){
                //e.preventDefault();
                $(document).trigger('abort.ajax');
                //window.history.back();
                console.log("backbutton pressed");
            });
            logger.setCnf({
                maxLogCache : 100000000000, //日志缓冲区最大容量
                level : logger.DEBUG, //日志级别,可以打开到DEBUG级别查看下面的assert断言
                logServer : ''     //日志服务器
            });
            require(['commonController/MainController'], function(MainController) {
                MainController.createWrapView();
                // 初始化PAWA框架
                PAWA.init({
                    isSPA : true,
                    defaultHash : "",
                    coreConfig : {
                        //这里是404，您还能配置更多状态码
                        //'404' : [handle404]
                    }
                });

                var getAppEnv=function(){//获取native app的运行环境
                    App.getConfig(function(data){
                        data = JSON.parse(data);
                        var section = 'product',
                            cfg = config.get();
                        switch ( true ) {
                            case data["CONFIG_TAG"].indexOf("dev") > -1 :
                                section = "development";
                                break;
                            case data["CONFIG_TAG"].indexOf("stg") > -1 :
                                section = "staging";
                                break;
                            case data["CONFIG_TAG"].indexOf("prd") > -1 :
                                section = "product";
                                break;
                        }
                        config.section(section);
                        window.DEBUG = cfg.debug && Boolean(cfg.section.indexOf('product') == -1);
                        var startoption=PAWA.PAWAModel.shareModels.get('StartOption');
                        window.location.replace('#'+PAGE_HASH[startoption.page]);


                    });
                }
                App.getStartPage(function(options){
                    try{
                        options=JSON.parse(options);
                    }catch(e){alert('获取参数失败');return;}
                    PAWA.PAWAModel.shareModels.add('StartOption',options);
                    getAppEnv();
                });
                //setTimeout(getAppEvnConfig,2000);
            })
            PAWA.PAWAModel.shareModels.add("AppModel", new (require("commonModel/AppModel")));
        };
    /*client.system.android
        ? require( ['lib/cordova-2.2.0'], function(){
                document.addEventListener("deviceready", initialize, false);
            } )
        :*/ initialize();
});

