/**
 * `应用所需公共数据
 * Created by 欣苇 on 13-12-18.
 */
define(["commonUtils/phonegap", "jq/purl", "config"], function(){
    var cfg = window.config.get(),
        phonegap = require("commonUtils/phonegap"),
        model;
    model = Backbone.Model.extend({
        defaults: {
            jid: "",//用户ID
            mobile: "",//用户手机号码
            location: [0,0],//用户当前精准位置
            position: {

            },
            hotCities:null,
            cities:null
        },
        initialize: function(options){
            /*phonegap.App.getCurrentUserJID(_.bind(function(data){ this.set("jid", data.jid)},this));
             phonegap.App.getCurrentUserMobile(_.bind(function(data){ this.set("mobile", data.mobile)},this));*/
        },
        locate: function(force){
            var self = this;
            if(!navigator.onLine){
                self.trigger("fetchCitiesFailure", "定位失败！");
                PAWA.request.param("status","noNet")
                return;
            }
            var errFn = function(err){
                    //alert("定位失败，无法获取周边网点！");
                    err && console.warn("code:%d message:%s", err.code, err.message);
                    self.trigger("locateFailure", "定位失败！");
                    console.log("locateFailure", this);
                    self.trigger("fetchCitiesFailure", "定位失败！");
                    PAWA.request.param("status","noNet");

                },
                positionToCity = function(Point){
                    var myGeo = new BMap.Geocoder();
                    // var bPoint = new BMap.Point(self.curLon,self.curLat);
                    self.trigger("locating", "正在识别经纬度所属城市...");
                    myGeo.getLocation(Point,function(rs){
                        if(rs != null &&  rs.addressComponents.city != '') {
                            var cityName = rs.addressComponents.city.replace("市", ""),
                                position = self.get("position")||{},
                                city = _.findWhere(self.get("cities"), {name: cityName});

                            position.city = cityName;
                            position.cityId = city.key;
                            position.regionCode = city.REGION_CODE;
                            self.set({
                                "position": position,
                                "location": [Point.lat,Point.lng]
                            });
                            self.trigger("locateSuccess", self);
                            setTimeout(function(){ self.set("position",{}) }, cfg.positionTimeout);
                            console.log("locateSuccess " + JSON.stringify(self.get("position")));

                        } else {
                            errFn( new Error("用经纬度查询城市失败") );
                        }
                    })
                };

            this.once("fetchCitiesSuccess", function(){
                //定位并设置城市位置
                //地址缓存
                self.trigger("locating", "定位中...");
                if (_.isEmpty(this.get("position")) || force) {
                    require([cfg.BMap.js], function(){
                        console.debug("position: "+ JSON.stringify($.url().param()) )
                        var url = $.url(),
                            pos = PAWA.PAWAModel.shareModels.get('StartOption') || {},
                            lon = url.param("lon")||pos.lon,
                            lat = url.param("lat")||pos.lat,
                            bPoint;

                        if ( lon && lat ) {
                           // var  userAgent = navigator.userAgent.toUpperCase();
                            //android用百度地图，不需要做转换
                            /*if(userAgent.indexOf("ANDROID")>0){
                                bPoint = new BMap.Point(lon, lat);
                            }else{*/
                                //火星经纬转百度经纬
                                var x_pi = 3.14159265358979324 * 3000.0 / 180.0;
                                var x = lon, y = lat,
                                    z = Math.sqrt(x * x + y * y) + 0.00002 * Math.sin(y * x_pi);
                                var theta = Math.atan2(y, x) + 0.000003 * Math.cos(x * x_pi);
                                var bd_lon = z * Math.cos(theta) + 0.0065,
                                    bd_lat = z * Math.sin(theta) + 0.006;

                                bPoint = new BMap.Point(bd_lon, bd_lat);
                            //}
                            positionToCity(bPoint);

                        } else {
                            //positionToCity({lat:self.curLat,lng:self.curLon});
                            var geolocation = new BMap.Geolocation();
                            geolocation.getCurrentPosition(function(r){
                                //关于状态码
                                //                        BMAP_STATUS_SUCCESS
                                //                        检索成功。对应数值“0”。
                                //                        BMAP_STATUS_CITY_LIST
                                //                        城市列表。对应数值“1”。
                                //                        BMAP_STATUS_UNKNOWN_LOCATION
                                //                        位置结果未知。对应数值“2”。
                                //                        BMAP_STATUS_UNKNOWN_ROUTE
                                //                        导航结果未知。对应数值“3”。
                                //                        BMAP_STATUS_INVALID_KEY
                                //                        非法密钥。对应数值“4”。
                                //                        BMAP_STATUS_INVALID_REQUEST
                                //                        非法请求。对应数值“5”。
                                //                        BMAP_STATUS_PERMISSION_DENIED
                                //                        没有权限。对应数值“6”。(自 1.1 新增)
                                //                        BMAP_STATUS_SERVICE_UNAVAILABLE
                                //                        服务不可用。对应数值“7”。(自 1.1 新增)
                                //                        BMAP_STATUS_TIMEOUT
                                //                        超时。对应数值“8”。(自 1.1 新增)
                                if(this.getStatus() == BMAP_STATUS_SUCCESS){  //获取百度地图经纬度
                                    positionToCity(r.point);
                                } else self.trigger("locateFailure", this.getStatus());

                            }, { timeout:cfg.positionTimeout });
                        }

                    }, _.bind(errFn, this));

                    /*window.DEBUG && this.set({
                     "position": {city:"深圳",cityId:"10034"},
                     "location": [22.5631245,114.0904636]
                     });*/

                } else {
                    self.trigger("locateSuccess", self);
                }

            }, this);
            self.trigger("locating", "读取城市列表...");
            this.fetchCities();
        },
        /* fetchCities: function(){
         if ( !_.some([this.get("hotCities"), this.get("cities")], _.isEmpty) ) {
         this.trigger("fetchCitiesSuccess", this);
         } else {
         var self=this;
         var cities = localStorage.getItem("cities"),hotCities=localStorage.getItem("hotCities"),nowTime = new Date().getTime(),saveTime=Number(localStorage.getItem("saveTime")),maxTime = 7*24*60*60*1000;//7天为过期时间
         if(!cities ||!hotCities || (saveTime+maxTime) <nowTime){
         require(["homeData/hotCities"], _.bind(function(hotCities){
         //$.get(cfg.service.cities,_.bind(function(cities){
         require(["homeData/citydata"], _.bind(function(cities){
         self.set({
         "hotCities":hotCities.hotList,
         "cities":cities.list
         });
         localStorage.setItem("cities",JSON.stringify(cities.list));
         localStorage.setItem("hotCities",JSON.stringify(hotCities.hotList));
         localStorage.setItem("saveTime",nowTime);
         self.trigger("fetchCitiesSuccess", self);
         },self));
         },self), _.bind(function(){
         this.trigger("fetchCitiesFailure", "城市数据获取失败！");
         },self));
         }else{
         self.set({
         "hotCities":JSON.parse(localStorage.getItem("hotCities")),
         "cities":JSON.parse(localStorage.getItem("cities"))
         });
         self.trigger("fetchCitiesSuccess", self);
         }

         }
         }*/
        fetchCities: function(){
            if ( !_.some([this.get("hotCities"), this.get("cities")], _.isEmpty) ) {
                this.trigger("fetchCitiesSuccess", this);
            } else {
                var self=this;
                var cities = localStorage.getItem("cities"),hotCities=localStorage.getItem("hotCities"),nowTime = new Date().getTime(),saveTime=Number(localStorage.getItem("saveTime")),maxTime = 7*24*60*60*1000;//7天为过期时间
                if(typeof cities ==='string' && cities === 'undefined'){
                    localStorage.clear();
                }
                if(!cities ||!hotCities || (saveTime+maxTime) <nowTime){
                    require(["homeData/hotCities"], _.bind(function(hotCities){
                        $.ajax({
                            url: cfg.service.cities,
                            dataType:"text",
                            timeout:1000 * 30,
                            success:function(cities){
                                self.set({
                                    "hotCities":hotCities.hotList,
                                    "cities":JSON.parse(cities).body
                                });
                                localStorage.setItem("cities",JSON.stringify(JSON.parse(cities).body));
                                localStorage.setItem("hotCities",JSON.stringify(hotCities.hotList));
                                localStorage.setItem("saveTime",nowTime);
                                self.trigger("fetchCitiesSuccess", self);
                            },
                            error:function() {
                                self.trigger("fetchCitiesFailure", "城市数据获取失败！");
                            }
                        })

                    },self), _.bind(function(){
                        self.trigger("fetchCitiesFailure", "城市数据获取失败！");
                    },self));
                }else{
                    self.set({
                        "hotCities":JSON.parse(localStorage.getItem("hotCities")),
                        "cities":JSON.parse(localStorage.getItem("cities"))
                    });
                    self.trigger("fetchCitiesSuccess", self);
                }

            }
        }
    })
    return model;
});