/**
 * Native开发人员自定义的API.
 * User: 欣苇
 * Date: 13-7-11
 * Time: 上午10:36
 * To change this template use File | Settings | File Templates.
 */
define(['helper/Support', 'underscore'], function(support){
    var sys = support.system,//设备检测，做适配所需的信息
        File,
        Notification,
        Device,
        Camera,
        Capture,
        Connection,
        Contacts,
        Storage,
        String,
        Globalization,
        UI,
        App,
        PhoneGap = {},

        callindex = 0, toString = Object.prototype.toString,
        call = function(name) {
            // 获取传递给Native方法的参数
            var args = Array.prototype.slice.call(arguments, 1);
            var callback = '', item = null;

            // 遍历参数
            for(var i = 0, len = args.length; i < len; i++) {
                item = args[i];
                if(item === undefined) {
                    item = '';
                }

                // 如果参数是一个Function类型, 则将Function存储到window对象, 并将函数名传递给Native
                if(toString.call(item) == '[object Function]') {
                    callback = name + 'Callback' + i;

                    window[callback] = item;
                    item = callback;
                }
                args[i] = item;
            }

            if(sys.android) {// Android平台
                try {
                    for(var i = 0, len = args.length; i < len; i++) {
                        // args[i] = '"' + args[i] + '"';
                        args[i] = '\'' + args[i] + '\'';
                    }
                    eval('window.android.' + name + '(' + args.join(',') + ')');
                } catch(e) {
                    console.log(e)
                }
                eval();
            } else if(sys.iphone) {// IOS平台
                if(args.length) {
                    args = '|' + args.join('|');
                }
                // IOS通过location.href调用Native方法, _call变量存储一个随机数确保每次调用时URL不一致
                callindex++;
                location.href = '#ios:' + name + args + '|' + callindex;
            }
        };
    /**
     * File(文件操作) API
     */
    File = PhoneGap.File = {};

    /**
     * Notification(消息通知) API,
     */
    Notification = PhoneGap.Notification = {};

    /**
     * Device(设备信息) API
     */
    Device = PhoneGap.Device = {};

    /**
     * Camera(相机，扫描) API
     */
    Camera = PhoneGap.Camera = {};

    /**
     * Capture(访问audio, image, video等)
     */
    Capture = PhoneGap.Capture = {};

    /**
     * Capture(访问audio, image, video等)
     */
    Connection = PhoneGap.Connection = {};

    /**
     * Capture(访问audio, image, video等)
     */
    Contacts = PhoneGap.Contacts = {};

    /**
     * Storage(数据存储) API
     */
    Storage = PhoneGap.Storage = {};

    /**
     * String(字符串处理，加密解密等) API
     */
    String = PhoneGap.String = {};

    /**
     * Globalization 国际化/本地化。语言，日期时间，金额
     */
    Globalization = PhoneGap.Globalization = {};

    UI = PhoneGap.UI = {};

    /**
     * App相关接口
     */
    App = PhoneGap.App = {};
    //获取当前用户天下通账号
    //callback: 返回的数据格式是字符串
    // 获取失败：{"result":"No","error":"获取JID失败！"}
    // 获取成功：{"result":"Yes", "jid":"ABCDEFG12345HIJKLMN0987" "error":""}
    App.getCurrentUserJID = function(callback) {
        var fnName = _.uniqueId("callback");
        if(App.IS_NATIVE){
            window[fnName] = function(){
                callback([].slice.apply(arguments).map(JSON.parse));
                delete window[fnName];
            };
            App.call('getCurrentUserJID', fnName);
        }else{
            //虚拟返回JID
            var rs = JSON.parse('{"result":"Yes", "jid":"12345678", "error":""}');
            callback(rs);
        }
    }

    //获取当前用户手机号
    //callback: 返回的数据格式是字符串
    // 获取失败：{"result":"No","error":"获取手机号失败！"}
    // 获取成功：{"result":"Yes", "mobile":"15817343910" "error":""}
    App.getCurrentUserMobile = function(callback){
        var fnName = _.uniqueId("callback");
        if(sys.mobile){
            window[fnName] = function(){
                callback([].slice.apply(arguments).map(JSON.parse));
                delete window[fnName];
            };
            App.call('getCurrentUserMobile', fnName);
        }else{
            //虚拟返回JID
            var rs = JSON.parse('{"result":"Yes", "mobile":"15817343910", "error":""}');
            callback(rs);
        }
    }

    return PhoneGap;
});