/**
 * Created with IntelliJ IDEA.
 * User: EX-LINKAIBIN001
 * Date: 13-9-29
 * Time: 上午10:09
 * Notes added By JINMENGJIE107
 * To change this template use File | Settings | File Templates.
 */
/**
 * 验证手机号,密码等 的工具
 */
define(function () {
    var myreg = /^(((13[0-9]{1})|(15[0-9^4]{1})|(18[5-9]{1})|180|181|182)+\d{8})$/;
    var numreg = /^[0-9]{11}$/;
    var OtpReg = /^[0-9]{6}$/;     //验证码 6 位数字
    var passwordExp = /^[\w\d\_]{6,16}$/;   //字母数字以及'_',6到16位之间  也可以这样写/^\w{6,16}$/
//    var nameExp = /^[a-zA-Z0-9\!\$\^\&\*\+\#@%()_~]{1,20}$/;
    var nameExp = /^[^\s\&]{1,20}$/;    //除了空格和'&'符号 , 1到20字节长度
    var heartExp = /^[a-zA-Z]+[a-zA-Z0-9]{5,20}$/;  //心号 首字母为字母,字母加数字5到20位




    var validateUtils = {
        /**
         * 获取字符串长度
         * @param text 待处理的字符串
         * @return 字符串长度
         */
        getByteLength : function(text) {
            return text.replace(/[^\u0000-\u00ff]/g, "00").length;
        },
        CheckId: {
        	//验证手机号格式
            checkPhoneNo: function (mobile) {
                var flag = true;
                if (mobile.length == 0) {
                    wrapView.showTips({info:'手机号不能为空！'});
                    flag = false;
                } else if (mobile.length != 11) {
                    wrapView.showTips({info:'请输入有效的手机号码！'});
                    flag = false;
                } else if (!myreg.test(mobile)) {
                    wrapView.showTips({info:'请输入有效的手机号码！'});
                    flag = false;
                }
                return flag;
            },
            //验证是否为手机号
            isPhoneNo:function(mobile){
                var flag = false;
                if( (numreg.test(mobile))&&(mobile.length == 11)&&(myreg.test(mobile))){
                    flag = true;
                    return flag;
                }
                return flag;

            },
            /**
             * 处理过长字符串的显示
             * @param text 待处理的字符串
             * @param length 保留长度
             * @param paddingRight 处理后被截取部分显示形式
             * @return 处理后的结果{string}
             */
            subPaddingByteStr: function(text, length, paddingRight) {
                var charIndex = 0;
                for(var i = 1, tLen = validateUtils.getByteLength(text); i <= length && i<=tLen; i ++, charIndex ++) {
                    if(text.charCodeAt(charIndex) > 255) {
                        i ++;
                    }
                }
                if(i > length) {
                    return text.substring(0, charIndex) + paddingRight;
                } else {
                    return text;
                }
            },
            //字母开头,20位以内数字和字母的组合
            isHeartId:function(text){
                heartExp.lastIndex=0;
                var flag = heartExp.test(text);
                return flag;
            }
        },
        checkOtp:{
            //判断是否为符合的验证码
            isOTP:function(text){
                OtpReg.lastIndex=0;
                var flag = OtpReg.test(text);
                return flag;
            }
        },
        checkPassword:{
            //判断是否为密码
             isPassword:function(text){
                 passwordExp.lastIndex=0;
                 var flag  = passwordExp.test(text);
                 return flag;
             }
        },
        checkName:{
            /**
             * 传入需要检测的名字字符串
             * @param text
             */
           isAbleName:function(text){
                var flag = true,len = validateUtils.getByteLength(text);
                if(len>20 || len<1){
                    flag = false;
                    return flag;
                }else{
                    nameExp.lastIndex=0;
                    if((!nameExp.test(text))){
                        flag = false;
                        return flag;
                    }
                }
                return flag;
           }
        },
        transText:{
            transBrackets:function(str){
                str=str.replace(/&/g,"&amp;").replace(/</g,"&lt").replace(/>/g,"&gt");
                return str;
            }
            /*decodeBrackets:function(){
                str.replace(/"&lt"/g,"<");
                str.replace(/"&gt"/g,">");
            }*/
        }
    }
    window.validateUtils = validateUtils;
    return validateUtils;
});