/**
 * POS(Point Of Service)网点查询控制器
 * Created by 欣苇 on 13-12-17.
 */
define([
    "PAWAAll",
    "commonView/pageView",
    "helper/Registry",
    "homeModel/POSModel",
    "config",
    "helper/Support"
],
    function(PAWA, PageView, Registry) {
        var registry = new Registry("POS"),
            cfg = require("config").get(),
            client = require('helper/Support'), isMobile = client.system.mobile;
        isMobile=App.IS_NATIVE;
       //处理寿险的经纬度，可能是前面会加上n，s,w,e
        function detailLifeMap(geo){
            if(!geo)return false;
            if(/[NSWEnswe]/.test(geo)){
                return geo.slice(0);
            }else{
                return geo;
            }
        }
        return PAWA.PAWAController.extend({
            // 模块名
            module : 'home',
            // 控制器名
            name : 'POS',
            // actions
            actions : {
                "index":"index",
                "filter(/:city)(/:category)(/:keyword)":"filter",
                //"nearby(/:category)": "nearby",
                "detail": "detail",
                "search": "search",
                "locate": "locate",
                "map"   : "map"
            },
            __logCnf__:{
                moduleName: 'home',
                className: 'POSController'
            },
            views: {},

            AppModel: null,
            init: function(){
                this.AppModel = PAWA.PAWAModel.shareModels.get("AppModel");

                $(document).off("backbutton.POS").on("backbutton.POS", _.bind(function(){
                    this["back"]();
                }, this));
            },
            lastParam: null,
            back: $.noop,
            index: function(){
                //展示网点查询首页
                var ViewID = "index",
                    View = this.views[ViewID],
                    AppModel = this.AppModel;
                    /*filter = function(){
                        //接受并处理参数city, category, keyword
                        var params = {
                            category: category || this.collection.params.category,
                            city: city || AppModel.get("position").city,
                            cityId: (_.findWhere(AppModel.get("cities"), {name: city})||{})["key"],
                            keyword: keyword || this.collection.params.srhKeyword
                        };

                        _.extend(this.collection.params, params);
                        this.filter(params);
                    },*/
                    //args = _.values(arguments);

                if (View instanceof Backbone.View) {
                    View.focusPage();
                    //View.Header.title("网点查询");
                    //if (!_.isEqual(this.lastParam, args) && city) {
                        //AppModel.once("fetchCitiesSuccess", filter, View);

                        //this.lastParam = args;
                    //}

                } else {
                    require(['homeView/POSView','text!homeTpl/POS.html'], _.bind(function(POSView,POS){
                        var html = $(POS).filter("#"+ViewID).html();
                        View = this.views[ViewID] = new POSView({
                            "id":"index",
                            "$html": $(html),
                            $tpl: $(POS).filter("#item"),
                            collection: new (require("homeModel/POSModel")),
                            controller: this
                        });
                        View.render();
                        //View.Header.title("网点查询");
                        //if (!_.isEqual(this.lastParam, args) && city) {
                            //AppModel.once("fetchCitiesSuccess", filter, this.views[ViewID]);
                            //AppModel.fetchCities()
                            //this.lastParam = args;
                        //}
                    }, this));
                }
                //AppModel.fetchCities()
                //AppModel.locate();

                this.back= function(){
                    $(document).off("backbutton.POS");
                    App.backnative();
                };
            },
            filter: function(city, category, keyword){
                var ViewID = "index",
                    View = this.views[ViewID],
                    AppModel = this.AppModel,
                    filter = function(){
                        //接受并处理参数city, category, keyword
                        var params = {
                            category: category ,
                            city: city,
                            cityId: (_.findWhere(AppModel.get("cities"), {name: city})||{})["key"],
                            keyword: keyword,
                            regionCode: (_.findWhere(AppModel.get("cities"), {name: city})||{})["REGION_CODE"]
                        };

                        _.each(params, function(val, key){
                            View.collections.filter.params[key] = val
                        }, this);
                        this.filter(params);
                    };
                View.focusPage()
                //View.Header.title("网点查询");

                AppModel.once("fetchCitiesSuccess", filter, View);
                AppModel.fetchCities()

                this.back= function(){
                    $(document).off("backbutton.POS");
                    App.backnative();
                };
            },
            /**
             * `附近网点
             * @param category 筛选类别ATM、银行、信保网点
             */
            /*nearby: function(category){
                // 将附近网点页面标签使用独立集合对象渲染数据
                var model = PAWA.PAWAModel.shareModels.get("AppModel"),
                    nearby = _.bind(function(model){
                        model.once("locateSuccess", function(model){
                            *//*this.collection.params.cityId = model.get("position").cityId;
                            this.collection.params.city = model.get("position").city;
                            this.collection.params.lat = model.get("location")[0];
                            this.collection.params.lng = model.get("location")[1];*//*
                            //alert("cate")
                            var View = this.views["index"];
                            if( View ) {
                                View.nearby(category).focusPage();
                                View.Header.title("网点查询");
                            }
                        }, this);
                        model.locate();
                    }, this);

                if ( !model.get("cities") ) {
                    model.once("fetchCitiesSuccess", nearby, this);
                    model.fetchCities()
                } else nearby(model)
                this.back= function(){
                    $(document).off("backbutton.POS");
                    App.backnative();
                };
            },*/
            /**
             * `网点详情信息
             * @param id 数据id
             */
            detail: function(){

                var ViewID = "detail",
                    ctrler = this,
                    View = this.views[ViewID],
                    model =  PAWA.PAWAModel.shareModels.get("detailModel");
                if (View instanceof Backbone.View) {
                    View.focusPage().refresh( model );
                    //View.Header.title("网点详情");
                } else {
                    View = PageView.extend({
                        events: {
                            //"click .mapxqs": "direction",//在地图中推荐到达路线
                            "touchstart .telphone": "call",//呼叫
                            "tap a.back": function(e){
                                e.stopPropagation();
                                e.preventDefault();
                                ctrler.views["index"].focusPage();
                                PAWA.router.navigate("home/POS/index", {trigger: false, replace:true});
                            },
                            "click .banking-hours .info": function(e){
                                $(e.currentTarget).closest(".info").toggleClass("collapsed");
                            },
                            "tap .there":function(){
                                var appModel = PAWA.PAWAModel.shareModels.get("AppModel"),model =  PAWA.PAWAModel.shareModels.get("detailModel"),
                                    location = appModel.get("location"),
                                    point = new BMap.Point(  model.attributes.lng || detailLifeMap(model.attributes.COUNTER_ADDRESS_LONGITUDE), model.attributes.lat || detailLifeMap(model.attributes.COUNTER_ADDRESS_LATITUDE));
                                PAWA.PAWAModel.shareModels.add("fromUrl","detail");
                                PAWA.request.param("roadPoint",{startPoint:{lat:location[0],lon:location[1]},endPoint:{lat:point.lat,lon:point.lng}});
                                PAWA.router.navigate("home/POS/map",true);

                            }
                        },
                        tagName:"div",
                        initialize: function(options){
                            this.constructor.__super__.initialize.apply(this, arguments);
                            this.template = _.template(options.tpl);
                            this.once("MapCreated", function(){
                                this.setPoint(this.model);
                            }, this);

                            //var html = options.html;
                        },
                        render: function(){
                            this.constructor.__super__.render.apply(this, arguments);
                            this.refresh(this.model);
                            this.createUI();

                        },
                        createUI: function(){
                            //@todo building baidu map component
                            var $map = this.$('.map-container:first').text("地图加载中..."),
                                appModel = PAWA.PAWAModel.shareModels.get("AppModel");
                            require([cfg.BMap.js], _.bind(function(){
                                var map = this.Map = new BMap.Map( $map.empty()[0]),
                                    point = new BMap.Point(  this.model.get('lng') || detailLifeMap(this.model.get("COUNTER_ADDRESS_LONGITUDE")), this.model.get('lat')|| detailLifeMap(this.model.get("COUNTER_ADDRESS_LATITUDE"))),
                                    label = new BMap.Label(
                                        "",
                                        {"offset":new BMap.Size(20,-20)}
                                    ),
                                    marker = this.marker = new BMap.Marker(
                                        point,
                                        {icon: new BMap.Icon(
                                            "assets/images/UI/marker_red_sprite.png",
                                            new BMap.Size(27, 25) )}
                                    );

                                marker.setLabel(label);
                            map.enableScrollWheelZoom(true);
                                map.enableContinuousZoom();    //启用地图惯性拖拽，默认禁用
                                map.addControl(new BMap.ScaleControl());                    // 添加比例尺控件
                                map.addControl(new BMap.OverviewMapControl());              //添加缩略地图控件
                                map.addControl(new BMap.NavigationControl({anchor: BMAP_ANCHOR_TOP_RIGHT, type: BMAP_NAVIGATION_CONTROL_ZOOM}));  //右下角，仅包含缩放按钮
                                //map.addControl(new BMap.NavigationControl({anchor: BMAP_ANCHOR_TOP_RIGHT, type: BMAP_NAVIGATION_CONTROL_SMALL}));
                                map.centerAndZoom(point,19);//默认以北京为中心点
                                map.addOverlay(marker);
                                $map.find("span[_cid=1]").hide();
                                this.trigger("MapCreated");
                            }, this), function(){
                                var msg = '网络超时，地图加载失败！';
                                $map.text(msg);
                                console.warn(msg);
                            });
                        },
                        setPoint: function(model){
                            if ( !(this.Map instanceof BMap.Map) ) return;
                            var sectionEL=$('#detail').find('section'),
                                ulList=sectionEL.find('ul'),
                                divMap=sectionEL.find('div.map-container');
                            //console.log(sectionEL.height(),ulList.height(),divMap.height());
                          //  if(model.collection.params.category == "ATM"){

                               /* if(this.iscr){
                                    $(".xq_list").parent().css({height:"auto"})
                                    this.iscr.destroy();
                                }*/
                                divMap.height(sectionEL.height()-ulList.height());

                           // }else{
                                divMap.height(sectionEL.height()*0.6);
                                $(".xq_list").parent().height(sectionEL.height()*0.4+20);

                               /* if(model.get("lat") || model.get("COUNTER_ADDRESS_LATITUDE")){
                                    this.iscr?this.iscr.destroy():"";
                                    this.iscr = new iScroll($(".xq_list").parent().eq(0)[0], {
                                        hScroll: false,
                                        hScrollbar: false,
                                        vScrollbar: false,
                                        bounce:false})
                                }*/
                           // }
                            //判断如果在寿险的网点下没有经纬度，处理高度问题
                            if($(".xq_list").parent().siblings(".map-container").is(":visible")){
                                $(".xq_list").parent().css({position:"absolute",width:"100%",top:divMap.height()-20+"px","overflow-y":"scroll"});
                            }else{
                                $(".map-container").siblings().eq(0).css({"position":"relative",width:"100%",top:"auto","height":"auto"});
                            }
                            var map = this.Map;
                            /**
                             *直接设置marker的position
                             *移动地图panTo
                             *地图加载完毕事件tiles loaded
                             *地图尺寸导致可读性差（设备像素密度有关）
                             */
                            //map.clearOverlays();
                            console.log("MiniMap lat:"+model.get('lat')||detailLifeMap(model.get("COUNTER_ADDRESS_LATITUDE")) +" lng:"+ model.get('lng')||detailLifeMap(model.get("COUNTER_ADDRESS_LONGITUDE")));
                            var point = new BMap.Point( model.get('lng')||detailLifeMap(model.get("COUNTER_ADDRESS_LONGITUDE")), model.get('lat')||detailLifeMap(model.get("COUNTER_ADDRESS_LATITUDE"))),
                                marker = this.marker;//标注

                            marker.getLabel().setContent( model.get('name') || model.get('bankName')||model.get("COUNTER_NAME"));
                            marker.setPosition(point);

                            setTimeout(function(){
                                //map.panTo(point);
                                map.setCenter(point);

                                map.enableDragging();

                                //map.centerAndZoom(point, 19);
                            },500);
                        },
                        call: function(e){
                            var a = $(e.currentTarget).siblings().eq(0).find("a");
                            if(a.length>0){
                                var tel=a.eq(0).attr("tel");
                                tel? App.makeCall(tel):""
                            }

                        },
                        refresh: function(model) {
                            this.Content.$el.find(".xq_list").html( this.template({obj: _.extend(model.toJSON(), {category: model.collection.params.category})}) );
                            var curLoc =  ctrler.AppModel.get("location");
                            if(curLoc&&curLoc[0])this.$el.find(".mapxqs").eq(0).attr("curLat",curLoc[0]).attr("curLng",curLoc[1]);
                            if(model.get("lat") || model.get("COUNTER_ADDRESS_LATITUDE")){
                                this.Map && this.setPoint(model);
                                $(".map-container").show();
                                this.$el.find(".there").eq(0).show();
                            }else{
                                $(".map-container").hide();
                                this.$el.find(".there").eq(0).hide();
                                if(this.iscr){
                                    this.iscr.destroy();
                                }
                                $(".map-container").siblings().eq(0).css({position:"relative",top:"auto",width:"100%","height":"auto"});

                            }

                        },
                        direction :function(e){
                            var model = this.model;
                            App.getMapDetail(model.get("lat"),model.get("lng"), model.get('bankName') || model.get('name'));
                        }
                    });
                    require(['text!homeTpl/POS.html'],_.bind(function(POS){
                        var html = $(POS).filter("#"+ViewID).html();
                        View = this.views[ViewID] = new View({
                            "id":"detail",
                            //html:html,
                            $html: $(html),
                            tpl: $(POS).filter("#"+ViewID+"_tpl").html(),
                            model: model
                        });
                        View.render();
                        $("#detail .map-container").bind("touchmove",function(e){e.stopPropagation();e.preventDefault();})
                        $("#detail").bind("touchmove",function(e){e.stopPropagation();})
                        //View.Header.title("网点详情");
                    }, this));
                }
               // this.views["index"] && this.views["index"].detail(id);

                this.back= function(){
                    ctrler.views["index"].focusPage();
                    PAWA.router.navigate("home/POS/index", {trigger:false,replace:true});
                    ctrler.back = function(){
                        $(document).off("backbutton.POS");
                        App.backnative();
                    }
                };
            },
            //定位当前城市
            locate: function(){
                var ctrler = this,
                    ViewID = "locate",
                    View = this.views[ViewID],
                    indexView = this.views["index"];

                if (View instanceof Backbone.View) {
                    View.focusPage();
                    //View.Header.title("选择城市");
                } else {
                    View = PageView.extend({
                        events: {
                            "change input.search": "filter",//筛选城市
                            "tap .position-city>div:not(.locating),.cities>li, .hot-cities>li": "choose",//选定城市
                            "vmouseover, tap >.letter>ul>li": "linkBar"
                        },
                        bizEvents: [
                            "once fetchCitiesSuccess", "fetchCitiesFailure",
                            "locateSuccess", "once locateFailure"
                        ],
                        initialize: function(options){
                            this.constructor.__super__.initialize.apply(this, arguments);

                        },
                        render: function(){
                            this.constructor.__super__.render.apply(this, arguments);
                            var $positionCity = this.$(" .content > .position-city ");
                            this.locateSuccess = function(model){
                                var city = model.get("position").city,pos=_.findWhere(model.get("cities"),{name:city});
                                $positionCity.children("div").removeClass("locating").add( this.$(">.header>:header>span") ).text(city).attr("regioncode", pos.REGION_CODE);
                            }
                            this.fetchCitiesSuccess = function(model){
                                //展示城市列表
                                var $docFragment = $(document.createDocumentFragment()),
                                    $hotCities = $("<ul class=\"hot hot-cities\">"),
                                    $divider = $("<div class=\"p_10 divider\">"),
                                    $cities = $("<ul class=\"cityCap cities\">"),
                                    //$linkBar = $("<ul>"),
                                    letter,
                                    letters = [];

                                $divider = $divider.clone().text("热门城市");
                                _.each(model.get("hotCities"), function(city){
                                    $hotCities.append( "<li data-id=\""+ city.key +"\" regioncode=\""+city.REGION_CODE+"\">"+ city.name +"</li>" )
                                }, this)
                                $docFragment.append($divider, $hotCities);

                                _.each(model.get("cities"), function(city){
                                    if ( letter != city.letter ) {
                                        letter = city.letter;
                                        letters.push(letter);
                                        $divider = $divider.clone().text(city.letter);
                                        $cities = $cities.clone().empty();
                                        $docFragment.append($divider, $cities);
                                    }
                                    $cities.append( "<li data-id=\""+ city.key +"\" regioncode=\""+city.REGION_CODE+"\">"+ city.name +"</li>" )
                                }, this)

                                //linkBar
                                /*_.each(letters, function(letter){
                                    $linkBar.append("<li>"+ letter +"</li>");
                                }, this);
                                this.$el.children(".letter").html($linkBar);*/
                                var $letter = this.$(">.letter > ul > li");
                                $letter.css("line-height", $(window).height() / $letter.size() +"px");

                                $positionCity.after($docFragment);
                              // WIS=new iScroll($("#pageCity")[0],{ hScroll:false,hScrollbar:false,vScrollbar:false});
                            }

                            this.model.fetchCities();
                            this.model.locate();
                        },
                        linkBar: function(e) {
                            //实现listview的linkbar交互，根据首字母自动定位至divider
                            var selector = "> .content > .divider:contains(\""+ $(e.currentTarget).text() +"\")",
                                divider = this.$(selector),
                                top;

                            if (divider.size()) {
                                top = divider.offset().top - this.Content.$el.offset().top;
                                divider.length > 0 && this.Content.$el.clearQueue().animate( { scrollTop: "+="+top }, function(){
                                    console.debug(divider[0], "page scrollTop:"+ this.scrollTop, "divider offsetTop:"+ top);
                                });
                            }
                        },
                        filter: function(){
                            //@todo ?显示城市筛选结果
                        },
                        //用户选定城市后调转
                        choose: function(e){
                            var city = $(e.currentTarget).text(),
                                cityId = $(e.currentTarget).data("id"),
                                collection = indexView.collections.filter;
                            e.preventDefault();
                            e.stopPropagation();
                            collection.params.city = city;
                            //ctrler.collection.params.cityId = cityId;
                            var obj = $("#lifeCities li:contains("+city+")");
                            collection.params.regionCode=$(e.currentTarget).attr("regioncode") || (obj.length>0 && obj.attr("regioncode"));
                            collection.params.regionCode && $("li.filter.city").attr("regioncode",collection.params.regionCode);
                            ctrler.filter(city);
                            !isMobile && window.history.back();
                            //PAWA.navigate(ctrler.module +"/"+ ctrler.name + "/filter/"+ city);
                        }
                    });
                    require(["commonModel/AppModel", "text!homeTpl/POS.html"], _.bind(function(model, tpl){
                        var html = $(tpl).filter("#"+ViewID).html();
                        View = this.views[ViewID] = new View({
                            $html: $(html),
                            model: PAWA.PAWAModel.shareModels.get("AppModel"),
                            id: "locate",
                            controller: this
                        })
                        this.views[ViewID].render();
                        //View.Header.title("选择城市");
                    }, this));

                }
                this.back= function(){
                    ctrler.views["index"].focusPage();
                    PAWA.router.navigate("home/POS/index", {trigger: false, replace:true});
                    ctrler.back = function(){
                        $(document).off("backbutton.POS");
                        App.backnative();
                    }
                    //window.history.back();
                };
            },
            search: function(){
                var ViewID = "search",
                    ctrler = this,
                    View = this.views[ViewID],
                    indexView = this.views["index"];

                if (View instanceof Backbone.View) {
                    View.focusPage().history();
                    //View.Header.title( "关键词查询" );
                    if($("select[name=category]").val()=="life"){
                        $("#noSearch").show().siblings(".content").hide();
                        $("input.search").attr("disabled","true").val("")
                    }else{
                        $("#noSearch").hide().siblings(".content").show();
                        $("input.search").removeAttr("disabled");
                    }
                } else {
                    View = PageView.extend({
                        events: {
                            "keydown input.search": function(e){
                                if (e.which == 13) {
                                    this.enter.apply(this, arguments);
                                }
                            },//筛选城市
                            "tap #delInputVal" : "clearInput",
                            "click .history > li": "choose",//选定选定关键词
                            "tap .clear-history": "clear",//清除历史记录
                            "click .search ~ .button": function(e){
                                e.preventDefault();
                                /*$(e.currentTarget).prev(".search").blur().val("");
                                //PAWA.navigate( this._hash() )
                                ctrler.filter.apply(ctrler, this._hash());
                                !isMobile && window.history.back();*/
                                this.enter.apply(this, arguments);
                            }
                        },
                        $history: null,
                        $suggestion: null,
                        storage: null,
                        historyMax: 30,
                        initialize: function(options){
                            this.constructor.__super__.initialize.apply(this, arguments);
                            this.$history = this.$(".history");
                            this.$suggestion = this.$(".suggestion");
                            this.storage = options.storage;

                            this.$("input.search").val( indexView.collections.filter.params.keyword );
                            this.on("pageshow", function(){
                                this.$("input.search").focus();
                            });
                        },
                        render: function(){
                            this.constructor.__super__.render.apply(this, arguments);
                            this.history(this._keyword());
                            if($("select[name=category]").val()=="life"){
                                $("#noSearch").show().siblings(".content").hide();
                                $("input.search").attr("disabled","true")
                            }else{
                                $("#noSearch").hide().siblings(".content").show();
                                $("input.search").removeAttr("disabled");
                            }
                        },
                        enter: function(e) {
                            var collection = indexView.collections.filter,
                                keyword = collection.params.keyword = this.$("input.search").val();

                            $(e.currentTarget).blur();
                            //PAWA.navigate( this._hash(keyword) );
                            ctrler.filter.apply(ctrler, this._hash(keyword));
                            !isMobile && window.history.back();
                            //PAWA.router.navigate("home/POS/index", {trigger: false, replace:true});
                        },
                        /**
                         * `展示历史记录
                         * @param keywords
                         */
                        history: function(keywords){
                            _.isString(keywords) && (keywords = [keywords]);
                            //展示历史关键词列表
                            var $docFragment = $(document.createDocumentFragment()),
                                $item = this.$history.children();
                            $docFragment.empty();
                            _.each(keywords||this._keyword(), function(keyword){
                                $item.filter(":contains(\""+ keyword +"\")").remove();
                                $docFragment.prepend($("<li>").text(keyword));
                            }, this)
                            if ($docFragment.children().length > 0) {
                                this.$history.prepend($docFragment)
                                    .add( this.$(".clear-history").parent() ).show(0);
                                var total = this.$history.children().length;
                                if ( total > this.historyMax ) {
                                    this.$history.children().slice(this.historyMax, total).remove();
                                }
                            }
                        },
                        
                        clearInput:function(e){
                            e.preventDefault();e.stopPropagation();
                        	$(e.currentTarget).parent().find(".search").val("").focus();
                        },
                        choose: function(e){
                            var keyword = indexView.collections.filter.params.keyword = $(e.currentTarget).text();
                            this.$("input.search").val(keyword);
                            //PAWA.navigate( this._hash(keyword) );
                            ctrler.filter.apply(ctrler, this._hash(keyword));
                            !isMobile && window.history.back();
                            console.debug(e.currentTarget);
                        },
                        clear: function(e){
                            this.$history.empty();
                            this.$(".clear-history").parent().hide(0);
                            this.storage.removeItem("search-history");
                            console.debug(e.currentTarget)
                        },
                        _hash: function(keyword){
                            var city = indexView.collections.filter.params.city ||ctrler.AppModel.get("position").city,
                                category = indexView.collections.filter.params.category,
                                //fragments = [ctrler.module, ctrler.name, "filter", city];
                                fragments = [city];

                            city && category && fragments.push(category);

                            //DEBUG && (cityId=cityId||"深圳", category=category||"ATM");
                            if ( !_.isEmpty(keyword) ) {
                                this._keyword(keyword);
                                category && fragments.push(keyword);
                            }
                            //return fragments.join("/").replace(/\/+$/, "");
                            return fragments;
                        },
                        /**
                         * Manage the history list of keywords
                         * @param {String} keyword
                         * @private
                         */
                        _keyword: function(keyword) {
                            var history = this.storage.getItem("search-history")||[],
                                oldKey;
                            //get keywords from history
                            if (_.isUndefined(keyword)) return history;
                            //set keyword into history
                            oldKey = history.indexOf(keyword)
                            oldKey > -1 && history.splice(oldKey,1);
                            keyword.trim().length > 0 && history.push(keyword);
                            if (history.length > this.historyMax) history = _.last(history, this.historyMax);
                            this.storage.setItem("search-history", history);
                        }
                    });
                    require(["text!homeTpl/POS.html", "helper/Storage"], _.bind(function(tpl, storage){
                        var html = $(tpl).filter("#"+ViewID).html();
                        View = this.views[ViewID] = new View({
                            id:"search",
                            $html: $(html),
                            storage: new storage("POS", "local"),
                            controller: this
                        });
                        this.views[ViewID].render();
                        //View.Header.title("关键词查询");
                    }, this))
                }
                this.back= function(){
                    this.views[ViewID].$("input.search").blur();//收起输入法
                    ctrler.views["index"].focusPage();
                    PAWA.router.navigate("home/POS/index", {trigger: false, replace:true});
                    ctrler.back = function(){
                        $(document).off("backbutton.POS");
                        App.backnative();
                    }
                    //window.history.back();
                };
            },
            map: function(startPoint, endPoint, type){    window.T=this;
                this.back= function(){
                    var fromUrl = PAWA.PAWAModel.shareModels.get("fromUrl");
                    if (fromUrl == 'detail') {
                        PAWA.router.navigate("home/POS/detail", {trigger: true, replace: true});
                    }
                    else {
                        PAWA.router.navigate("home/POS/index", {trigger: true, replace: true});
                    }
                };

              var roadPoint = PAWA.request.param("roadPoint"),map=this.mapt,transit=this.transit,$ul=this.$ul,p1=this.p1,p2=this.p2;
               var ViewID ="map",
                   View = this.views[ViewID];
               if (View instanceof Backbone.View) {
                    View.focusPage();
                   this.p1 = new BMap.Point(roadPoint.startPoint["lon"],roadPoint.startPoint["lat"]);
                   this.p2 = new BMap.Point(roadPoint.endPoint["lon"],roadPoint.endPoint["lat"]);
                   this.transit.clearResults();
                   if($(".tab li:first").hasClass("focus")){
                       this.transit = new BMap.WalkingRoute(map, {
                           renderOptions: {map: map}
                       });
                       $ul.find("li").removeClass("focus").eq(0).addClass("focus");
                   }else{
                       this.transit = new BMap.DrivingRoute(map, {
                           renderOptions: {map: map}
                       });
                       this.$ul.find("li").removeClass("focus").eq(2).addClass("focus");
                   }
                   this.transit.search(this.p1, this.p2);

               }else{
                   require([cfg.BMap.js,"text!homeTpl/POS.html"],  _.bind(function(bmap, tpl){
                       var html = $(tpl).filter("#"+ViewID).html(),self = this;
                       this.$ul = $($(html)[2]).clone();
                       View = this.views[ViewID] = new PageView({
                            $html: $(html),
                            id: "map",
                            controller: this
                        })
                       this.views[ViewID].render();

                       // 百度地图API功能
                       map = this.mapt = new BMap.Map(ViewID);            // 创建Map实例

                       map.enableContinuousZoom();    //启用地图惯性拖拽，默认禁用
                       map.addControl(new BMap.ScaleControl());                    // 添加比例尺控件
                       map.addControl(new BMap.OverviewMapControl());              //添加缩略地图控件
                       map.addControl(new BMap.NavigationControl({anchor: BMAP_ANCHOR_TOP_LEFT, type: BMAP_NAVIGATION_CONTROL_ZOOM}));  //右下角，仅包含缩放按钮


                      //map.centerAndZoom(new BMap.Point(roadPoint.endPoint["lon"], roadPoint.endPoint["lat"]), 12);
                       this.p1 = new BMap.Point(roadPoint.startPoint["lon"],roadPoint.startPoint["lat"]);
                       this.p2 = new BMap.Point(roadPoint.endPoint["lon"],roadPoint.endPoint["lat"]);
                      if($(".tab li:first").hasClass("focus")){
                          this.transit = new BMap.WalkingRoute(map, {
                              renderOptions: {map: map}
                          });
                      }else{
                           this.transit = new BMap.DrivingRoute(map, {
                               renderOptions: {map: map}
                           });
                          this.$ul.find("li").removeClass("focus").eq(2).addClass("focus");
                      }
                       this.transit.search(this.p1, this.p2);
                       //start--------添加三个按钮控件 ----------
                       // 定义一个控件类，即function
                       function trafficBtnControl(){
                           // 设置默认停靠位置和偏移量
                           this.defaultAnchor = BMAP_ANCHOR_TOP_RIGHT;
                           this.defaultOffset = new BMap.Size(10, 10);
                       }
    // 通过JavaScript的prototype属性继承于BMap.Control
                       trafficBtnControl.prototype = new BMap.Control();
    // 自定义控件必须实现initialize方法，并且将控件的DOM元素返回
    // 在本方法中创建个div元素作为控件的容器，并将其添加到地图容器中
                       trafficBtnControl.prototype.initialize = function(map){
    // 绑定事件
                           self.$ul.show();
                           self.$ul.bind("click",function(e){
                               e.stopPropagation();
                               var trafficType = e.target.nodeName == "LI" ? $(e.target).attr("type"):"";
                               $(e.target).addClass("focus").siblings().removeClass("focus");
                               switch (trafficType){
                                   case "bus":
                                       self.transit.clearResults();
                                       self.transit = new BMap.TransitRoute(map, {
                                           renderOptions: {map: map}

                                       });
                                       self.transit.setSearchCompleteCallback(function(results){
                                           if(self.transit.getStatus() == 3){
                                               var firstPlan = results.getPlan(0);
                                               if(!firstPlan || firstPlan.getNumLines()<=0){

                                                   alert("没有查找到公交线路");
                                               }
                                          }
                                       })

                                       self.transit.search(self.p1, self.p2);
                                       break;
                                   case "car":
                                       self.transit.clearResults();
                                       self.transit = new BMap.DrivingRoute(map, {
                                           renderOptions: {map: map}
                                       });
                                        self.transit.search(self.p1, self.p2);
                                       break;
                                   case "walking":
                                       self.transit.clearResults();
                                       self.transit = new BMap.WalkingRoute(map, {
                                           renderOptions: {map: map}
                                       });
                                       self.transit.search(self.p1, self.p2);

                                       break;
                                   default:

                               }
                           })
    // 添加DOM元素到地图中
                           map.getContainer().appendChild(self.$ul[0]);
                           return self.$ul[0];
                       }
    // 创建控件实例
                       var trafficBtnCtrl = new trafficBtnControl();
    // 添加到地图当中
                       map.addControl(trafficBtnCtrl);
                     //end--------------------------------------
                   },this), function(){
                        var msg = '网络超时，加载失败！';
                        //$map.text(msg);
                        console.warn(msg);
                   });
                }
            }
        });
    });