define([
    "PAWAAll",
    "commonView/pageView",
    "text!homeTpl/PhoneCallback.html",
    "helper/Registry",
    "homeModel/PhoneCallModel",
    "config"
],
    function(PAWA, PageView, tpl, Registry) {
        var registry = new Registry("PhoneCallback"),
            cfg = require("config").get();
        var HomeController = PAWA.PAWAController.extend({
            // 模块名
            module : 'home',
            // 控制器名
            name : 'bank',
            // actions
            actions : {
				"index":"index",
                "callback": "callback",
                "modTel": "modTel",
                "callSuccess": "callSuccess",
                "offline": "offline",
                "waiting": "waiting"
            },
            __logCnf__:{
                moduleName: 'home',
                className: 'HomeController'
            },
            views: {},
            model: null,
			init: function(){
                var Model = require("homeModel/PhoneCallModel");
                this.model = new Model;
			},
			index:function(){
				/*require(['homeView/CardHeaderView','homeView/CardBodyView'], function(CardHeaderView,CardBodyView) {
					var wrapView = PAWA.PAWAView.shareViews.get("wrapView");
                    wrapView.setHeader(CardHeaderView, {});
					wrapView.setBody(CardBodyView, {});
				})*/

                console.debug("Here is home/bank/index");
			},

            callback: function(){
                var ViewID = "callback",
                    View = this.views[ViewID];
                if (View instanceof Backbone.View) {
                    View.focusPage();
                } else {
                    require([
                        "text!homeTpl/PhoneCallback.html"
                    ], _.bind(function(tpl){
                        View = PageView.extend({
                            $form: null,
                            events: {
                                "tap a[data-rel=popup]": function(e){
                                    e.preventDefault()
                                    var ui = this.ui(),
                                        $anchor = $(e.currentTarget),
                                        selector = $anchor.attr("href");

                                    if ($anchor.hasClass("ui-state-disabled")) {
                                        return false;
                                    }
                                    ui.popup( selector, "toggle" );
                                    ui.popup( selector, "reposition");
                                },
                                "tap #select-service .spring": function(e){
                                    var $spring = $(e.currentTarget),
                                        $springboard = $spring.closest(".springboard"),
                                        $springElements = $springboard.find(".spring"),
                                        hash,
                                        notInServiceTime,
                                        ui = this.ui(),
                                        $popup = $spring.closest(".ui-popup-container"),
                                        $message = this.$(".message.not-in-service-time"),
                                        reposition = function() {
                                            ui.popup($popup, "reposition");
                                        };

                                    $springboard.addClass("selected")
                                    $springElements.removeClass("highlight");
                                    $spring.addClass("highlight")
                                        .children("input[type=radio]").prop("checked", true)
                                        .trigger("change");

                                    if ( !navigator.onLine ) {
                                        hash = "offline";
                                    } else if ( registry.get("waiting") ) {
                                        hash = "waiting";
                                    } else {
                                        //@todo 发起立即回拨请求
                                        this.model.callback( this.$form.serializeJSON().channel );
                                        /*hash = Math.random() > 0.5 ? "callSuccess" : "offline";
                                        notInServiceTime = Math.random() > 0.5 ? true : false;*/
                                    }
                                    //callbacks for View
                                    this.noService = function(){
                                        $message.stop(true, true).show(0, reposition).delay(10000).hide(0, reposition);
                                    }
                                    this.callFailure = alert;
                                    this.callSuccess = function(){
                                        $springboard.removeClass("selected")
                                        $spring.removeClass("highlight")
                                        ui.popup($popup, "toggle");
                                        $message.hide();
                                        PAWA.navigate("home/bank/" + hash);
                                    }
                                    /*if ( hash == "callSuccess" && notInServiceTime ) {

                                    } else {

                                    }*/
                                }
                            },
                            initialize: function(options){
                                this.constructor.__super__.initialize.apply(this, arguments);
                                this.$form = this.$(".content form");
                                var $phoneNumber = this.$(".phone.number.field.container > b")
                                    ,placeholder = $phoneNumber.data("placeholder");
                                $phoneNumber.text( this.model.get("phone") || placeholder );

                                //业务模型事件绑定
                                this.listenTo(this.model, "noService",   function(){ this["noService"]() });
                                this.listenTo(this.model, "callSuccess", function(){ this["callSuccess"]() });
                                this.listenTo(this.model, "callFailure", function(){ this["callFailure"]() });
                                this.listenTo(this.model, "failure", function(jqXHR, textStatus, errorThrown){
                                    alert("真抱歉，系统未能成功处理这次请求，请稍后再试。");
                                });
                                //获取地理位置
                                var $selectService = this.$(".ui-button.select-service"),
                                    defaultText = $selectService.text(),
                                    positioningText = $selectService.data("positioning");

                                $selectService.addClass("ui-state-disabled").text(positioningText);
                                navigator.geolocation.getCurrentPosition(_.bind(function(position){
                                    this.model.set("location", [position.coords.latitude, position.coords.longitude]);
                                    $selectService.removeClass("ui-state-disabled").text(defaultText);

                                }, this), _.bind(function(err){//定位失败
                                    console.warn("code:%d message:%s", err.code, err.message);
                                    $selectService.removeClass("ui-state-disabled").text(defaultText);

                                }, this), { timeout:cfg.positionTimeout });
                            },
                            noService: $.noop,
                            callSuccess: $.noop,
                            callFailure: $.noop
                        });
                        var html = $(tpl).filter("#"+ViewID).html();
                        View = this.views[ViewID] = new View({
                            $html: $(html),
                            id: ViewID,
                            model: this.model
                        }).render();
                    }, this));

                }

            },

            modTel: function(){
                var ViewID = "modTel",
                    views = this.views,
                    View = views[ViewID];

                if (View instanceof Backbone.View) {
                    View.focusPage();
                } else {
                    require([
                        "homeView/PhoneCallView",
                        "text!homeTpl/PhoneCallback.html"
                    ], _.bind(function(View, tpl){
                        var html = $(tpl).filter("#"+ViewID).html();
                        views[ViewID] = new View({
                            $html: $(html),
                            id: ViewID,
                            model: this.model
                        }).render();
                    }, this));
                }
            },

            callSuccess: function(){
                var ViewID = "callSuccess",
                    View = this.views[ViewID],
                    seconds = 2 * 60 * 1000,
                    timer;

                if (View instanceof Backbone.View) {
                    View.focusPage();
                } else {
                    View = PageView.extend({
                        events: {}
                    });
                    var html = $(tpl).filter("#"+ViewID).html();
                    this.views[ViewID] = new View({
                        $html: $(html),
                        id: ViewID
                    }).render();
                }

                registry.set("waiting", true);
                timer = setTimeout(function(){
                    registry.remove("waiting"), clearTimeout(timer);
                }, seconds);
            },

            offline: function(){
                var ViewID = "offline",
                    View = this.views[ViewID];
                if (View instanceof Backbone.View) {
                    View.focusPage();
                } else {
                    View = PageView.extend({
                        events: {}
                    });
                    var html = $(tpl).filter("#"+ViewID).html();
                    this.views[ViewID] = new View({
                        $html: $(html),
                        id: ViewID
                    }).render();
                }
            },

            waiting: function(){
                var ViewID = "waiting",
                    View = this.views[ViewID];
                if (View instanceof Backbone.View) {
                    View.focusPage();
                } else {
                    View = PageView.extend({
                        events: {}
                    });
                    var html = $(tpl).filter("#"+ViewID).html();
                    this.views[ViewID] = new View({
                        $html: $(html),
                        id: ViewID
                    }).render();
                }
            }
        });
        return HomeController;
    });
