/**
 * POS(Point Of Service)网点查询业务模型
 * Created by 欣苇 on 13-12-17.
 */
define(["config", "commonUtils/phonegap"], function(){
    var cfg = config.get(),
        phonegap = require("commonUtils/phonegap"),
        model;
    //单条网点信息数据
    model = Backbone.Model.extend({
        defaults: {
            //@todo 定义id字段
            distance: 0//网点距离当前位置的距离
        },
        initialize: function(options){

        }

    });
    //多条网点信息数据集合
    return Backbone.Collection.extend({
        model: model,
        AppModel:null,
        initialize: function(options){
            this.AppModel = PAWA.PAWAModel.shareModels.get("AppModel");
            this.listenTo(this.AppModel, "locateSuccess", function(model){
                //this.params.cityId = model.get("position").cityId;
                //this.params.city = model.get("position").city;
                this.params.lat = model.get("location")[0];
                this.params.lng = model.get("location")[1];
                this.params.regionCode = model.get("position").regionCode;
            }, this);

            $(document).ajaxStop(function(event){
                $(this).off('abort.POS');
            });
        },
        url: "",
        params: {
            city: "",
            cityId:"",
            lat:0,
            lng:0,
            category: "",
            keyword: "",
            regionCode:""
        },
        /**
         * `重写数据解析方法
         * @param response 后端相应数据
         * @param options
         */
        parse: function(response, options){

            var models = response.list || response.queryResult;

            return models;
        },

        nearby: function(category){
            return this.filter({
                lat:this.params.lat,
                lng:this.params.lng,
                category: category || this.params.category,
                cityId: this.AppModel.get("position").cityId,
                regionCode:this.AppModel.get("position").regionCode
            });
        },
        /**
         * //条件查询
         * @param {Object} opts
         */
        filter: function(opts) {
            //todo city参数处理
            opts = opts || {};
            var category = opts.category,
                cityId = opts.cityId;
            /* if ( _.some([String(cityId), category], _.isEmpty) ) {
             console.warn("参数不足，cityId:%s, category:%s", cityId, category);
             this.trigger("failure", "请选择城市与业务类型");
             return;
             } */

            /*if (_.isEqual(this._lastOtps, opts)) {
             console.info("传入参数与上次一样，无需再次请求");
             return;
             }*/
            this._lastOtps = opts
            if($("nav li:eq(0)").hasClass("focus") && category!=$(".category .active").attr("data-tab"))return;
            if(category=="ATM"){
                this.url=cfg.service.nearATM;
            }else if(category=="bank"){
                this.url=cfg.service.nearBank;
            }else if(category=="life"){
                this.url=cfg.service.nearLife;

            }
            this.params = {};
            this.params.currentPage = 1;

            var startIdx = this.length,
                params = _.extend(this.params, {
                    coordinate:"Y"
                }, opts),
                options = {
                    cache: true,
                    dataType: category=="life"?"json":"jsonp",
                    data: params,
                    success: _.bind(function(collection, response, options){
                        if(response.list){
                            this.totalPage = response.totalPage;

                            this.trigger("fetchPOSSuccess", collection.slice(startIdx), response);
                            collection.length == 0 && this.trigger("fetchPOSError", "当前网点暂无查询结果");
                        }else{
                            this.totalPage = 1;
                          //  collection.params.category = "life";
                            this.trigger("fetchPOSSuccess", collection.slice(startIdx), response);
                            response.queryResult.length == 0 && this.trigger("fetchPOSError", "当前网点暂无查询结果");
                        }


                    }, this),
                    error: _.bind(this.reqErrorHandle, this)
                }, jqXHR;

            if((category=="life"&&!opts.regionCode)||(category!="life"&&!opts.cityId)){
                this.trigger("fetchPOSError", "当前网点暂无查询结果");
                return false;
            }
            if($(".tab li:eq(0)").hasClass("focus")||($(".tab li:eq(1)").hasClass("focus")&&$("select[name=category]").val() && $("input[name=city]").val())){
                jqXHR = this.fetch(options);

                //allow abort for Ajax request during anytime
                $(document).one('abort.POS', options, _.bind(function(e){
                    console.info('POSModel: abort request of URL:'+this.url);
                    jqXHR.abort();
                }, this));
            }
            return jqXHR;
        },
        /**
         * `下一页
         * @param page
         */
        next: function(page){
            if(!this.url && navigator.onLine){
                this.AppModel.fetchCities();
                console.log("POSModel__next")
                return;
            }
            if (!this.url || !navigator.onLine) {
                this.trigger("failure", "网络数据加载失败！");
                return;
            }
            var startIdx = this.length,
                params = _.extend({}, this.params, {
                    currentPage: page || this.params.currentPage + 1
                }),
                options = {
                    dataType: params.category=="life"?"json":"jsonp",
                    data: params,
                    timeout:1000 * 30,
                    remove: false,
                    success: _.bind(function(collection, response, options){
                        this.trigger("fetchNextPageSuccess", collection.slice(startIdx), response)
                        //this.trigger("fetchNextPageError")
                        this.params.currentPage = params.currentPage;

                    },this),
                    error: _.bind(this.reqErrorHandle, this)
                }, jqXHR;

            if ( params.currentPage <= this.totalPage || PAWA.request.param("status")) {
                if(!this.totalPage)params.currentPage=1;
                jqXHR = this.fetch(options);

                //allow abort for Ajax request during anytime
                $(document).one('abort.POS', options, function(e){
                    console.info('POSModel: abort request of URL:'+this.url);
                    jqXHR.abort();
                });
            } else {
                this.trigger("failure", "没有更多内容了...");
            }
        },
        detail: function(id){
            return this.get(id);
        },
        reqErrorHandle: function(collection, response, options){
            if(response.statusText=="timeout" || response.statusText=="error" || response.statusText=="abort" || response.statusText=="failed" || (response.statusText == "load" || response.statusText == "OK" && collection.length==0))
                PAWA.request.param("status",response.statusText);//修复因异常原因重新后不能发送请求
            switch (response.statusText) {
                case "timeout" :
                    response.statusText = "请求超时。";
                    break;
                case "error" :
                    response.statusText = "网络不可用。";
                    break;
                case "abort" :
                    response.statusText = "请求被终止。";
                    break;
                case "failed":
                    response.statusText = "请求发生错误。";
                    break;
                case "OK" :
                    response.statusText = "请求发生错误。";
                    break;
            }
            this.trigger("failure", response.statusText);

        },
        /**
         * `测距
         */
        ranging: function(models){
            //todo 调用测距API,直接修改传进的集合，由集合中的模型触发事件，从而驱动视图更新

        }
    });

});