/**
 * Created by 欣苇 on 13-12-16.
 */
define(["config", "commonUtils/phonegap"], function(){
    var cfg = require("config").get(),
        phonegap = require("commonUtils/phonegap");
    return Backbone.Model.extend({
        defaults: {
            location: [0,0],
            biz: "1001"
        },
        initialize: function(options){
            phonegap.App.getCurrentUserJID(_.bind(function(data){ this.set("jid", data.jid)}, this));
            phonegap.App.getCurrentUserMobile(_.bind(function(data){ this.set("phone", data.mobile)}, this));
        },
        sendOTP: function(mobile){
            var OTPNotSent = _.bind(function (data){
                this.trigger("OTPNotSent", "获取验证码失败！！", data);
            }, this);

            return $.post(cfg.service.API("OTPSend"), {"phone":mobile}, $.noop, "json")
                .done(_.bind(function(data, textStatus, jqXHR){
                    var errCode = data.resultCode;
                    switch (true) {
                        case errCode == 0:
                            console.info("code:%d info:%s", errCode, data.resultMessage);
                            this.trigger("OTPSent")
                            break;
                        case [1,2].indexOf(errCode) > -1:
                            console.error("code:%d info:%s", errCode, data.resultMessage)
                            OTPNotSent(data)
                            break;
                    }
                }, this))
                .fail(_.bind(function(jqXHR, textStatus, errorThrown){
                    OTPNotSent();
                }, this));
        },
        validateOTP: function(phrase){
            return $.post(cfg.service.API("OTPValidate"),
                {"phone":this.get("phone"), "validateCode": phrase}, $.noop, "json")
                .done(_.bind(function(data, textStatus, jqXHR){
                    var errCode = data.resultCode,
                        print = "log";
                    switch (true) {
                        case errCode == 0:
                            print = "info"
                            this.trigger("OTPValid");
                            break;
                        case [1,2].indexOf(errCode) > -1:
                            print = "error";
                            this.trigger("OTPInvalid", "验证码校验失败！！", data);
                            break;
                    }
                    console[print]("code:%d info:%s", errCode, data.resultMessage)
                }, this))

                .fail(_.bind(function(jqXHR, textStatus, errorThrown){
                    this.trigger("failure", arguments);
                }, this));
        },
        callback: function(channel){
            return $.post(cfg.service.instanceBackCall, {
                    "pNum": this.get("phone"),
                    "taskseries": this.get("biz"),
                    "taskType": channel,
                    "gcxy": this.get("location").join(","),
                    "obPhone":this.get("phone"),
                    "tx_num":this.get("jid")
            })
                .done(_.bind(function(data, textStatus, jqXHR){
                    var errCode = data.resultCode,
                        print = "log";
                    switch (true) {
                        case errCode == 0:
                            print = "info";
                            this.trigger("callSuccess");
                            break;
                        case [1,2].indexOf(errCode) > -1:
                            print = "error";
                            this.trigger("callFailure", "呼叫失败！！", data);
                            break;
                        case 3:
                            print = "info";
                            this.trigger("noService", "呼叫失败！！", data);
                            break;
                    }
                    console[print]("code:%d info:%s", errCode, data.resultMessage)
                }, this))

                .fail(_.bind(function(jqXHR, textStatus, errorThrown){
                    this.trigger("failure", arguments);
                }, this));
        }
    });

});