/**
 * POS(Point Of Service)网点查询视图
 * Created by 欣苇 on 13-12-17.
 */
define(["commonView/pageView", "lib/UI/iscroll", "native",'helper/Support'], function(PageView){
    //处理寿险的经纬度，可能是前面会加上n，s,w,e
    function detailLifeMap(geo){
        if(!geo)return false;
        if(/[NSWEnswe]/.test(geo)){
            return geo.slice(0);
        }else{
            return geo;
        }
    }
    var ItemView,
        trail = ["找平安","网点查询"],
        client = require('helper/Support'), isMobile = client.system.mobile;
    isMobile=App.IS_NATIVE;
    //单条网点数据视图对象
    ItemView = Backbone.View.extend({
        attributes: {

        },
        tagName:"li",
        initialize: function(options) {
            this.template = options.template;
            //this.listenTo(this.model, "change:distance", function(model, value, options){
            //@todo 更新距离
            //   })
        },
        render: function(model){
            var html= this.template(_.extend(this.model.toJSON(), {category: this.model.collection.params.category}));
            this.$el.html(html);
            var curLoc = this.model.collection.AppModel.get("location");
            if(curLoc&&curLoc[0])this.$el.find(".map").eq(0).attr("curLat",curLoc[0]).attr("curLng",curLoc[1]);
            return this;
        }
    });

    return PageView.extend({
        events: {
            "tap .tab li": "tab",//标签页切换
            "tap .filter.category, #select-choice-category .cancel": "category",//选择业务类型
            "tap .filter.city": function(e){
                e.preventDefault();
                e.stopPropagation();
                $(document).one("titled", function(){
                    trail.splice(3);
                    trail[3] = document.title;
                    App.talkingDataTrack( trail.join(">") )
                });
                isMobile ? PAWA.navigate("home/POS/locate") : PAWA.router.navigate("home/POS/locate", {trigger:true});
                console.log("navigate home/POS/locate");

            },
            "click .filter.keyword":function(e){
                $(document).one("titled", function(){
                    trail.splice(3);
                    trail[3] = document.title;
                    App.talkingDataTrack( trail.join(">") );
                });
                isMobile ? PAWA.navigate("home/POS/search") : PAWA.router.navigate("home/POS/search", {trigger:true});
                console.log("navigate home/POS/search");

            },
            "tap .wd_list li:not(.disabled,.active)": "nearby",//展示附近网点列表
            "tap .result_list > li > .summary": "detail",//展示详细信息
            "tap .result_list > li > .bus": "detail",//寿险公交
            "tap .callNum":"tel",
            "tap .map": "direction",//在地图中推荐到达路线
            //"click ": "call",//呼叫
            "swipeleft .result_list":"previousPage",
            "swiperight .result_list":"nextPage",
            "click a[backnative=backnative]":"backnative" //返回native
        },
        //bizEvents:,
        fetchPOSSuccess: $.noop,
        fetchPOSError: $.noop,
        fetchNextPageSuccess: $.noop,
        fetchNextPageError: $.noop,
        failure: $.noop,
        locateFailure: $.noop,
        locating: $.noop,

        $filterForm: null,
        AppModel:null,
        callbacks:{},
        initialize: function(opts){
            this.constructor.__super__.initialize.apply(this, arguments);
            this.AppModel = PAWA.PAWAModel.shareModels.get("AppModel");
            this.controller = opts.controller;

            this.collections = {
                nearby: this.collection.clone(),
                filter: this.collection
            };
            setTimeout(_.bind(function(){
                this.$(".tab li").first().tap();
                this.nearby("ATM");
            }, this), 0);
            //this.tabName = "nearby";


            var events = [
                "fetchPOSSuccess",
                "fetchPOSError",
                "fetchNextPageSuccess",
                "fetchNextPageError",
                "failure",
                "fetchCitiesFailure"
            ];
            _.each(this.collections, function(collection, key){
                this.callbacks[key] = this.callbacks[key] || {};
                _.each(events, function(event){
                    if ( !_.isFunction(this.callbacks[key][event]) ) this.callbacks[key][event] = function(){};
                    this.listenTo( collection , event, function(){
                        this.callbacks[key][event].apply(this, arguments);
                    }, this);
                }, this);

            }, this);

            /*this.listenTo(this.AppModel, 'locateSuccess', function(model){//定位成功后自动更新城市选择
             this.fillFields( {city:model.get("position").city} );
             });*/
            //this.listenTo(this.collection, 'add', this.addItem);
            this.listenTo(this.AppModel, 'locateFailure', function(){
                this.locateFailure.apply(this, arguments);
            });
            this.listenTo(this.AppModel, 'locating', function(){
                this.locating.apply(this, arguments);
            });
            this.listenTo(this.AppModel, 'fetchCitiesFailure', function(){
                this.fetchCitiesFailure.apply(this, arguments);
            });
        },
        fetchCitiesFailure:function(msg){
            $(".pullUp").removeClass("loading").find(".pullUpLabel").html(msg);
            //IOS7下不显示，再执行显示
            $(".pullUp").each(function(){
                if($(this).css("display") == "block"){
                    $(this).css("display","block");
                }
            })
        },
        render: function(){
            this.constructor.__super__.render.apply(this, arguments);

            this.createUI();

        },
        createUI: function(){
            var $uiSelectCategory = this.$("#select-choice-category"),
                $ulCategory = $("<ul>"),
                $selectCategory = this.$(".filter.category > select"),
                ui = this.ui();

            //条件查询筛选分类选择部分
            $ulCategory.on("click", "li:not(.ui-disabled)", function(){
                var oldIdx = $selectCategory[0].selectedIndex,
                    newIdx = $ulCategory.children("li").index(this),
                    option = $selectCategory.children("option").eq(newIdx)[0];
                option.selected = true;
                oldIdx !== newIdx && $selectCategory.trigger( "change" );
                //$selectCategory.prev(".ui-select").text(option.text);
                ui.popup( $uiSelectCategory, "toggle" );
                //$( this ).toggleClass( "checked", option.selected );
            });
            $selectCategory.children("option").each(function(idx, el){
                var $li = $("<li>");
                idx == 0 && $li.addClass("ui-selectmenu-placeholder");
                $li.text( $(el).text()).appendTo($ulCategory);
            });
            $uiSelectCategory.html($ulCategory);
            $ulCategory.after( "<a href=\"#\" class=\"cancel\">取消</a>" );

            //表单域关联显示元素信息更新
            var $filterForm = this.$filterForm = this.$("form[name=filter]");
            $filterForm.find("[name=city], [name=keyword]").change(function(){
                var $el = $(this).closest("li").find(".ui-btn-inner");
                if ( !_.isEmpty($(this).val()) ) {
                    $el.text(this.value);
                } else {
                    $el.text( $el.data("placeholder") );
                }
            });
            $filterForm.find("[name=category]").change(function(){
                var $el = $(this).closest("li").find(".ui-btn-inner");
                if ( !_.isEmpty($(this).val()) ) {
                    $el.text( $(this).find(":selected").text() );
                    console.log("update text of category's label");
                } else {
                    $el.text( $el.data("placeholder") );
                    console.log("restore text of category's label");
                }
            });

            //iScroll for pulling data
            function iScrollFactory(wrapper, callback){
                var filterScroller,
                    pullUpEl, pullUpOffset, $page, $ul;

                pullUpEl = wrapper.querySelector('.pullUp');
                pullUpOffset = pullUpEl.offsetHeight;
                $page = $(wrapper).closest(".page");
                $ul = $(wrapper).find(">.scroller > ul");

                function pullUpAction() {
                    console.debug("pullUpAction");
                    $(pullUpEl).is(":visible") && callback();
                }

                wrapper.addEventListener('touchmove', function (e) { e.preventDefault(); }, false);

                filterScroller = new iScroll( wrapper, {
                    useTransition: true,
                    topOffset:0,
                    //snap:true,
                    //checkDOMChanges:true,
                    onRefresh: function () {
                        if(!navigator.onLine){ return;}
                        //$(this.scroller).children("ul").children().length > 0 && $(pullUpEl).show();
                        if ($(pullUpEl).hasClass('loading')) {
                            $(pullUpEl).removeClass('loading flip');
                            pullUpEl.querySelector('.pullUpLabel').innerHTML = '上拉加载更多...';
                        }

                    },
                    onScrollMove: function () {

                        if(!navigator.onLine){ return;}
                        if ( this.scrollerH > this.wrapperH && Math.abs(this.distY) >= 15 ) {
                            var isHidden = $page.hasClass("hidden-toolbar");
                            if(this.distY <= -15 && !isHidden){
                                $page.addClass("hidden-toolbar");
                                setTimeout(_.bind(function(){ this.refresh() }, this), 500);
                                console.log("hidden-toolbar");
                            } else if (this.distY >= 15 && isHidden) {
                                $(wrapper).closest(".page").removeClass("hidden-toolbar");
                                setTimeout(_.bind(function(){ this.refresh() }, this), 500);
                                console.log("show-toolbar");
                            }
                        }

                        if (this.y < (this.maxScrollY - 5) && !$(pullUpEl).hasClass('flip')) {
                            $(pullUpEl).removeClass("loading").addClass("flip")
                            pullUpEl.querySelector('.pullUpLabel').innerHTML = '释放刷新...';
                            this.maxScrollY = this.maxScrollY;
                        } else if (this.y > (this.maxScrollY + 5) && $(pullUpEl).hasClass('flip')) {
                            $(pullUpEl).removeClass("loading flip");
                            pullUpEl.querySelector('.pullUpLabel').innerHTML = '上拉加载更多...';
                            this.maxScrollY = pullUpOffset;
                        }
                        //网络不可用或超时需要再次发出请求
                        if(navigator.onLine && PAWA.request.param("status")){
                            $(pullUpEl).removeClass("flip").addClass('loading');
                            pullUpEl.querySelector('.pullUpLabel').innerHTML = '读取中...';
                            if(PAWA.request.param("status") == "noNet"){
                                PAWA.PAWAModel.shareModels.get("AppModel").locate();
                            }else
                                pullUpAction.apply(this);
                            PAWA.request.param("status",null);
                        }
                    },
                    onScrollEnd: function () {
                        if ($(pullUpEl).hasClass('flip')) {
                            $(pullUpEl).removeClass("flip").addClass('loading');
                            pullUpEl.querySelector('.pullUpLabel').innerHTML = '读取中...';
                            pullUpAction.apply(this);	// Execute custom function (ajax call?)
                        }
                    }
                });

                $(wrapper).data("iScroll", filterScroller);
            }

            this.$(".scroll-wrapper").each(_.bind(function(idx, el){
                iScrollFactory(el, _.bind(this.next,this));
            }, this));

            //this.$("#filter-scroller").data("iScroll", filterScroller);
            /*new iScroll(this.$(".result_list.filter"), {
             hScroll: false,
             hScrollbar: false,
             snap: true,
             momentum: true,
             onScrollEnd: function () {

             }
             });*/

            /*var startTime, startPageY;
             this.$el.on("dragstart", function(e){
             //console.log(e);
             if ( !startTime ) {
             startTime = e.timeStamp;
             startPageY = e.pageY;
             }
             });
             this.$el.on("drag", function(e){
             //console.log(e);
             if ( !startPageY || !startTime ) return;

             var pixel = e.pageY - startPageY,
             dragup = pixel < 0,
             times = e.timeStamp - startTime;

             if ( Math.abs(pixel) > 15 && times > 100) {
             console.log(dragup ? "hidden" : "show");
             startTime = startPageY = void 0;
             }
             });
             this.$el.on("dragend", function(e){
             //console.log(e);
             startTime = startPageY = void 0;
             });*/
        },
        //UI
        tab: function(e){
            var $li = $(e.currentTarget),index = $li.index(),
                $wrapper = this.$(".scroll-wrapper"),
                $pane;

            trail.splice(2);

            if(index==1){
                //!target.hasClass("focus") && this.filter();
                $(".select_list").show();
                this.tabName = "filter";
                $pane = $wrapper.filter(".filter").show();
                $wrapper.filter(".nearby").hide();
                $(".wd_list").hide();

                trail[2] = $li.text().trim();
                //PAWA.router.navigate("home/POS/filter");
            }else{
                $(".select_list").hide();
                this.tabName = "nearby";
                $pane = $wrapper.filter(".nearby").show();
                $wrapper.filter(".filter").hide();
                $(".wd_list").show();


                trail[2] = $li.text().trim();
                //PAWA.router.navigate("home/POS/nearby");

            }
            //$pane.height( $(window).height() - $pane.parent().offset().top );

            /*var $nav = $li.closest("nav");
             $nav.siblings(".content").first().css("padding-top",  $nav.outerHeight());*/
            $pane.closest(".content").attr("data-show-tab", this.tabName);
            $pane.data("iScroll").refresh();

            if(!$li.hasClass("focus")){
                $li.addClass("focus").siblings().removeClass("focus");
            }

            App.talkingDataTrack( trail.join(">") );

            this.controller.back = function(){
                $(document).off("backbutton.POS");
                App.backnative();
            };
        },
        category: function(e){
            e.preventDefault();
            var $uiSelectCategory = this.$("#select-choice-category"),
                ui = this.ui();
            ui.popup( $uiSelectCategory, "toggle" );
            this.$filterForm.find("[name=category]").off("change.category").one("change.category", _.bind(function(){
                var collection = this.collections[this.tabName];
                collection.params.category = this.$filterForm.find("[name=category]").val();
                var city = this.$filterForm.find("[name=city]").val();
                if(collection.params.category == "life"){
                    $("li.filter.keyword").find("span").html("关键字").attr("data-placeholder","关键字");
                    this.$filterForm.find("[name=keyword]").val("");
                }
                if(city)
                    this.filter( {
                        city: collection.params.city || city ,
                        cityId: collection.params.cityId ,
                        category: this.$filterForm.find("[name=category]").val(),
                        regionCode:$("li.filter.city").attr("regionCode")
                    } );
            },this))
        },
        //display
        reload:function(tab, empty){
            var $container = this.$(".scroll-wrapper."+ tab +" .result_list"),
                $pullUp = $container.next(".pullUp"),
                showError = function(msg){
                    switch (msg) {
                        case 1:
                            break;
                        case 2:
                            msg = "定位位置结果未知";
                            break;
                        case 3:
                            //msg = "导航结果未知";
                            break;
                        case 4:
                            msg = "百度地图API服务密钥失效";
                            break;
                        case 5:
                            msg = "百度地图API将定位请求认定为非法请求";
                            break;
                        case 6:
                            msg = "没有权限访问定位服务";
                            break;
                        case 7:
                            msg = "定位未开启或定位服务不可用！";
                            break;
                        case 8:
                            msg = "定位超时";
                            break;
                    }
                    $pullUp.show().removeClass("flip").addClass("pause").children(".pullUpLabel").html(msg)
                };

            if (($(".tab li:eq(0)").hasClass("focus")||($(".tab li:eq(1)").hasClass("focus") && $("select[name=category]").val()) )&& empty) {
                $container.empty();
                $pullUp.show().removeClass("pause").addClass("loading").children(".pullUpLabel").text("加载中...");
            }

            var callback = this.callbacks[tab];
            callback.fetchPOSSuccess = callback.fetchNextPageSuccess = function(models, response){
                //this.collection.ranging(models);//测距，更新距离信息
                var iScroll = $container.closest(".scroll-wrapper").data("iScroll");
                $pullUp.removeClass("pause");
                $pullUp[ response.totalPage > 1 ? "show" : "hide" ]().children(".pullUpLabel").text("上拉刷新...");
                $container[0].children.length == 0 && iScroll.scrollToPage(0,0);
                this.addItem(models, {$container: $container});
                iScroll.refresh();
            }
            callback.fetchPOSError = callback.fetchNextPageError = showError;
            callback.failure = callback.locating = callback.locateFailure = showError;
        },
        nearby: function(e){
            if(typeof e =="string"){
                var categary= e,
                    $el = this.$("ul.category li[data-tab="+ categary +"]");

            }else{
                var $el=  $(e.currentTarget);
                //if($el.hasClass('focus')){return 0;}
                var index = $el.attr('id'),categary="";

                e.preventDefault();

                if(index=='liOption1'){categary="ATM";}
                else if(index=='liOption2'){categary="bank";}
                else if(index=='liOption3'){categary="life"; }
                //$el.addClass("focus").siblings().removeClass("focus");
            }

            trail.splice(3);
            trail[3] = $el.text().trim();
            App.talkingDataTrack( trail.join(">") );
            $(document).trigger("abort.POS");

            var $li = this.$(".nearby.category").find("li").removeClass("active"),
                collection = this.collections[this.tabName];
            $li.filter("[data-tab="+categary+"]").addClass("active");
            this.reload(this.tabName, true);
            collection.reset();
            this.AppModel.once("locateSuccess", _.bind(function(){
                collection.nearby(categary);
            }, this));
            this.AppModel.locate();
            return this;
        },
        filter: function(opts){
            // 更新筛选选项列表
            opts = opts || {};

            $(document).trigger("abort.POS");//开始新请求前终止上一次请求

            var collection = this.collections[this.tabName];

            this.fillFields(opts);
            this.reload(this.tabName, true);
            collection.reset();
            collection.filter({
                city: opts.city,
                cityId: opts.cityId || collection.params.cityId ,
                category: opts.category || this.$("[name=category]").val(),
                srhKeyword: opts.keyword || this.$("[name=keyword]").val(),
                regionCode:opts.regionCode
            });
        },
        next: function(){
            var collection = this.collections[this.tabName];
            collection.next();
        },
        addItem: function(models, options){
            //集中一次性添加至DOM中 
            //@todo 使用DOM片段包含单项DOM元素以减少页面多次渲染造成响应缓慢
            options = options || {};
            var items = [], itemView, $container= options.$container||this.$(".result_list").eq(0);
            //修复还没定位成功就点寿险网点时产生的bug
            if(models.length>0 && models[0].collection.params.category=="life" && models[0].attributes.lat){
                return ;
            }
            _.each(models, function(model, idx){
                itemView = new ItemView({
                    model: model,
                    template: _.template( this.options.$tpl.filter('#item').html() )
                })
                items.push(itemView.render().$el.data("id", model.id||model.cid));
            }, this)
            $container.append( items );
        },
        detail: function(e){
            e.stopPropagation();e.preventDefault();
            var id = $(e.currentTarget).closest("li").data("id");
            //PAWA.request.param("indexModel",index);
            var collection = this.collections[this.tabName];

            $(document).one("titled", function(){
                trail.splice(3);
                trail[3] = document.title;
                App.talkingDataTrack( trail.join(">") );
            });

            PAWA.PAWAModel.shareModels.add("detailModel", collection.get(id));
            isMobile ? PAWA.navigate("home/POS/detail") : PAWA.router.navigate("home/POS/detail", {trigger:true});
            /* var id = 0,
             model = this.collection.detail(id);  */
        },
        tel:function(e){
            e.stopPropagation();e.preventDefault();
            var elem = e.target;
            if(elem.nodeName == "SPAN")elem = elem.parentNode;
            var callNo= elem.getAttribute("tel");
            App.makeCall(callNo);
        },
        /**
         * `调用地图寻路API
         */
        direction: function(e){
            var id = $(e.currentTarget).closest("li").data("id"),
                collection = this.collections[this.tabName],
                model = collection.get(id);
            e.preventDefault();
            e.stopPropagation();
            var //x_pi = 3.14159265358979324 * 3000.0 / 180.0,
                lifeLat = model.get("COUNTER_ADDRESS_LATITUDE"),
                lifeLng = model.get("COUNTER_ADDRESS_LONGITUDE");
            if(model.collection.params.category == "life" && (!lifeLat || !lifeLng)){
                  return;
            }
            if(model.collection.params.category == "life" && lifeLat && lifeLng){
                var x =  detailLifeMap(lifeLng), y = detailLifeMap(lifeLat);
            }else{
                var x = model.get("lng") , y = model.get("lat");
            }
            //var x = model.get("lng")-0.0065 , y = model.get("lat")-0.006;
           // var z = Math.sqrt(x * x + y * y) - 0.00002 * Math.sin(y * x_pi);
           // var theta = Math.atan2(y, x) - 0.000003 * Math.cos(x * x_pi);

           // var gg_lon = z * Math.cos(theta),
            //    gg_lat = z * Math.sin(theta);
            var location = this.AppModel.get("location");
            PAWA.PAWAModel.shareModels.add("fromUrl","index");
            PAWA.request.param("roadPoint",{startPoint:{lat:location[0],lon:location[1]},endPoint:{lat:y,lon:x}});
            isMobile ? PAWA.navigate("home/POS/map") : PAWA.router.navigate("home/POS/map", {trigger:true});

          //  App.getMapDetail(gg_lat,gg_lon, model.get('bankName') || model.get('name'));
            /*var id = 0,
             model = this.collection.detail(id),
             location = model.get("location");
             */
        },
        call: function(e){
            var t=$(e.target)
            if(e.target.tagName=="SPAN")t= t.parent();

        },
        backnative:function(e){
            //App.backnative();
        }
    });

})
