/**
 * Created by 欣苇 on 13-12-16.
 */
define(["commonView/pageView", "commonUtils/validator"], function(PageView){
    return PageView.extend({
        $form: null,
        $notice: null,
        events: {
            "tap .CAPTCHA .send": "sendOTP",
            "tap .submit .modify": "modify"
        },
        initialize: function(){
            this.constructor.__super__.initialize.apply(this, arguments);
            this.$form = this.$("form");
            this.$notice = this.$form.children(".notice");
            this.$form.validate({
                //debug: true,
                submitHandler: function(form){
                    return false;
                },
                errorPlacement: function(error, element) {//验证消息放置的地方
                    element.prop("placeholder", error.text());
                    console.debug("errorPlacement was called")
                },
                success: function(label, element){
                    $(element).prop("placeholder", $(element).data("placeholder"));
                    console.debug("success was called")
                },
                /*highlight: function(element, errorClass, validClass) {
                 console.debug("highlight was called")
                 },
                 unhighlight: function(element, errorClass, validClass) {
                 console.debug("unhighlight was called")
                 },*/
                ignore:".ignore",//不需要验证的elements样式
                errorClass: "error",
                validClass: "valid"//通过验证的样式类
            });

            //与业务模型进行事件绑定
            var $modifyBtn = this.$(".submit .modify");
            this.listenTo(this.model, "OTPSent", function(){
                this.notice("手机验证码正发往您的手机，请注意查收！");
            });
            this.listenTo(this.model, "OTPNotSent", this.notice);
            this.listenTo(this.model, "OTPValid", function(){
                var hash = $modifyBtn.attr("href");
                PAWA.navigate(hash);
            });
            this.listenTo(this.model, "OTPInvalid", function(msg){
                var failureText = $modifyBtn.data("failure-text");

                $modifyBtn.text(failureText);
                this.notice(msg);
            });
            this.listenTo(this.model, "failure", function(jqXHR, textStatus, errorThrown){
                this.notice("真抱歉，系统未能成功处理这次请求，请稍后再试。");
            });

            var $phoneNumber = this.$("#phone-number");
            $phoneNumber.val( this.model.get("phone") );
        },
        notice: function(msg){
            this.$notice.text(msg)
                .slideDown("slow").delay(2000).slideUp("slow");
        },
        sendOTP: function(e){
            var $button = $(e.currentTarget),
                waitText = $button.data("wait-text"),
                defaultText = $button.text(),
                seconds = 10,
                timer,
                counter = function(e){
                    $button.text( waitText.replace("%d", seconds) );
                    if ( seconds <= 0 ) clearInterval(timer), $button.text(defaultText).prop("disabled", false);
                    seconds--;
                };


            $button.prop("disabled", true)

            timer = setInterval(counter, 1000), counter();

            //发起短信验证码请求
            this.model.sendOTP( this.$form.find("#phone-number").val() );
        },
        modify: function(e){
            e.preventDefault();
            var button = $(e.currentTarget),
                defaultText = button.text(),
                validate = this.$form.validate();

            if (button.hasClass("ui-state-disabled") || !validate.form()) {
                validate.focusInvalid();
                return false;
            }

            button.addClass("ui-state-disabled");

            //验证短信验证码
            this.model.validateOTP( this.$form.find(".CAPTCHA [name=validateCode]").val()).always(function(){
                setTimeout(function(){
                    button.text(defaultText);
                    button.removeClass("ui-state-disabled");
                }, 1000)
            });
            /*setTimeout(function(){
                if (Math.random() > 0.5) {
                    window.location.hash = hash;
                } else {
                    button.text(failureText)
                }
                setTimeout(function(){
                    button.text(defaultText);
                    button.removeClass("ui-state-disabled");
                }, 1000)
            }, 1500);*/
        }
    });
})