define(["PAWAAll","config","native"],
    function(PAWA) {
        // 引入并继承MainController控制器
        var selfserver = PAWA.PAWAController.extend({
            // 模块名
            module : 'selfserver',
            // 控制器名
            name : 'selfserver',
            // actions
            actions : {
                "index/:product":"index",
                "recommendApp":"recommendApp"
            },
            __logCnf__:{
                moduleName: 'selfserver',
                className: 'selfserverCtr'
            },
            init: function(){
                $(document).off("backbutton.selfserver").on("backbutton.selfserver", _.bind(function(){
                    this["back"]();
                }, this));
            },
            back: $.noop,
            index:function(product){
                var cfg = config.get(),
                    url = "",
                    wrapView=   PAWA.PAWAView.shareViews.get("wrapView");

                wrapView.showWaiting({info:"正在加载中...."});
                $('body').addClass('recommendApp');
                url = require.toUrl( "selfserverdata/" + product + ".json" );
                /*switch (product){
                    case "101":
                        url = require.toUrl(config.get("service").selfserver101);
                        break;
                    case "104":
                        url = require.toUrl(config.get("service").selfserver106);
                        break;
                    case "106":
                        url = require.toUrl(config.get("service").selfserver106);
                        break;
                    default :
                        url = cfg.service.selfserver+product
                        break;
                }*/
                $.ajax({
                    type:"get",
                    dataType:"json",
                    url:url,
                    success:function(data){
                        require(['selfserverView/SelfServerBodyView'], function(SelfServerBodyView) {
                            //wrapView.setHeader(HeaderView, {});
                            PAWA.request.param("product",product);
                            wrapView.setBody(SelfServerBodyView, {model:data,product:product});

                            wrapView.hideWaiting();
                        })

                    },
                    error:function(XMLHttpRequest, textStatus, errorThrown){
                    	console.log(XMLHttpRequest);
                    	console.log(textStatus);
                    	console.log(errorThrown);
                    	wrapView.hideWaiting();
                    	setTimeout(function(){
                    		wrapView.showWaiting({info:"加载失败"});
                    	},200);

                    }
                })
                this.back= function(){
                    $(document).off("backbutton.selfserver");
                    App.backnative();
                };
            },

            recommendApp: function() {
                var mobileType = App.IS_IOS ? 0 : 1;
                var cfg = require("config").get();
                wrapView.showWaiting({info:"正在加载中...."});
                $('body').addClass('recommendApp');
                $.ajax({
                    type: "get",
                    dataType: "json",
                    url:cfg.service.PACollection + mobileType,
                    success: function(data) {
                        require(['selfserverView/HeaderView', 'selfserverView/RecommendApp'], function(HeaderView, RecommendApp) {
                            var wrapView = PAWA.PAWAView.shareViews.get("wrapView");
                            wrapView.setBody(RecommendApp, {
                                model: data
                            });
                            wrapView.hideWaiting();
                        });
                    },
                    error: function(XMLHttpRequest, textStatus, errorThrown) {
                    	console.log(XMLHttpRequest);
                    	console.log(textStatus);
                    	console.log(errorThrown);
                    	wrapView.hideWaiting();
                    	setTimeout(function(){
                    		wrapView.showWaiting({info:"加载失败"});
                    	},200);
                    }
                })
                this.back= function(){
                    $(document).off("backbutton.selfserver");
                    App.backnative();
                };
            }

        });
        return selfserver;
    });
