
define([
    "text!selfserverTpl/SelfserverBodyTem.html","native"
], function(SelfserverBodyTem) {
    var talkingDataName='找平安>';

    /**
     * 给链接添加参数： imNo和imType
     * @param obj 用于渲染的数据
     */
    function addImNoAndImType(obj) {
        var startOpts = PAWA.PAWAModel.shareModels.get("StartOption"),
            paramStr = "imNo=" + (startOpts.imNo || "") + "&imType=" + (startOpts.imType || "");
        addParam(obj, paramStr);
    }

    /**
     *给链接添加随机参数，防止缓存
     * @param obj 用于渲染的数据
     */
    function addRandomParam(obj) {
        var paramStr = '_=' + new Date().getTime();
        addParam(obj, paramStr);
    }

    /**
     * 加参数方法
     * @param obj model对象
     * @param paramStr 参数字符串
     */
    function addParam(obj, paramStr) {
        var results = obj.resultMessage;
        for(var i = 0, len = results.length; i < len; i ++) {
            var resultsObjList = results[i].leafList;
            for(var j = 0, jLen = resultsObjList.length; j < jLen; j ++) {
                var tempUrl = resultsObjList[j].url || "",
                    idx = tempUrl.indexOf("?"),
                    tLen = tempUrl.length,
                    urlCJ = tempUrl.split("#"),
                    hasHash = (urlCJ.length === 2),
                    _hash;
                if(hasHash) {
                    tempUrl = urlCJ[0];
                    _hash = urlCJ[1];
                }
                if(tempUrl && idx >= 0 && idx !== tLen-1) {
                    resultsObjList[j].url = tempUrl + "&" + paramStr;
                } else {
                    resultsObjList[j].url = tempUrl + "?" + paramStr;
                }
                if(hasHash) {
                    resultsObjList[j].url += "#"+_hash;
                }
            }
        }

    }
    var HomeView = PAWA.PAWAView.extend({
        tagName: "div",
        _template: _.template(SelfserverBodyTem),
		$el	:$(this.tagName),
        events: {
        	"click #backMain": "backMain",
            "touchstart .navSelfService li,touchstart .navList a":"talkingData",   //超链接点击会跳转，用touchstart优先处理talkingData
//"click .navSelfService a": "alertA",     //仅仅测试时用
            "click a#credit-card-public-no": "jumpToPublicChat"
        },
      
        __logCnf__:{
            moduleName: 'selfServer',
            className: 'SelfserverBodyView'
        },
/*alertA: function(e) {
    if(!confirm(e.currentTarget.href)) {
        e.preventDefault();
        e.stopPropagation();
        return false;
    }
},*/
        jumpToPublicChat: function(e) {
            localStorage.setItem("JUMP_TO_CREDIT_CARD", "Y");
            //this.$(".credit-circle").remove();
            this.$("#credit-card-public-no").removeClass("public-no-circle");
			App.talkingDataTrack(talkingDataName+$(e.currentTarget).children("p").html());
            App.jumpToPublicChat();
        },
        init: function(op) {
          this.options=op;
          this.render();
        },
        render: function() {
            var p=this.options.product,text="";
            this.model._product = p;
            switch (p){
                case "101":
                    text="银行";
                    break;
                case "102":
                    text="人寿";
                    break;
                case "103":
                    addImNoAndImType(this.model);
                    text="养老险";
                    break;
                case "104":
                    text="健康险";
                    break;
                case "105":
                    text="证券";
                    break;
                case "106":
                    addRandomParam(this.model);
                    text="信用卡";
                    break;
                case "107":
                    addImNoAndImType(this.model);
                    text="产险";
                break;
            }
            talkingDataName+=text+'>';
            $("header h1").html(text+"自助服务");
			this.$el.html(this._template(this.model));
            //new iScroll(this.el,{hScroll:true});
            var bodyHeight = document.body.offsetHeight;
            if(bodyHeight > 0){
                this.$el.children("#tiepian").css("height",bodyHeight+"px");
            }
        },
        talkingData:function(e){
            var liname=(e.currentTarget.getAttribute('data-name'));
            App.talkingDataTrack(talkingDataName+liname);
        },
        destroy: function() {
            this.remove();
        },
        backMain:function(){
        	App.gotoPublic('10027@publicservice.pingan.com.cn');
        }
    });
    return HomeView;
});
