;(function(appCache, undefined) {
    var BBNativeCallbacks = window.BBNativeCallbacks  = {counter: 0, namespace: "BBNativeCallbacks"},
        ua = navigator.userAgent.toUpperCase(),
        isAndroid = ua.indexOf("ANDROID") >= 0,
        isIos = ua.indexOf("IPHONE OS") >= 0,
        loop = function(){};


    if(typeof Function.prototype.bind !== 'function') {
        Function.prototype.bind = function(context) {
            return function() {
                this.apply(context, arguments);
            }
        }
    }
    function callNative(methodName) {
        var args = Array.prototype.slice.call(arguments, 1),
            callback = '',
            item = null,
            callbackName = '';
        //遍历参数 
        for(var i = 0, len = args.length; i < len; i ++) {
            item = args[i];
            if(undefined === item) {
                item = '';
            }

            //如果参数是函数类型，则将该函数存储到BBNativeCallbacks命名空间下 
            if(typeof item === 'function') {
                callbackName = "callback" + (BBNativeCallbacks.counter ++);
                callback = BBNativeCallbacks.namespace + "." + callbackName;
                BBNativeCallbacks[callbackName] = item;
                args[i] = callback;
            }
        }
        if(isAndroid) {
            var argStr = '';
            if(args.length) {
                argStr = "'" + args.join("','") + "'";
            }
            eval("BB." + methodName + "(" + argStr + ")");
        } else if(isIos) {
            args.push(BBNativeCallbacks.counter);
            var href = encodeURI("bbcachenative://" + methodName + "|" + args.join("|"));
            try{
                var iframe = document.createElement("iframe");
                iframe.src = href;
                iframe.style.display = "none";
                document.body.appendChild(iframe);
                iframe.parentNode.removeChild(iframe);
                iframe= null;
            }catch(e){
                location.href = href
            }
        }
    }
    //首先中断自动进行更新的动作 
    if(!window.BB) {
        window.BB = {printInfo: console.log.bind(console), toldNativeAppCached: function(){console.log("Told native app this application cached OK.")}}
    }
    var BBVersionManager = window.BBVersionManager = {
        userCallbacks: {
            onUpdateOk: loop,   //更新成功 
            onProgress: loop,   //更新失败 
            onRemove: loop,     //当缓存的资源因服务器操作失误而被删除时 
            onFirstCached: loop,//当资源首次被缓存成功了 
            onUpdate: loop,     //当开始下载 
            onNoUpdate: loop,   //当没有更新时触发(当前已是最新版本) 
            onCheck: loop,      //开始检查版本更新时触发 
            onError: loop       //当更新过程中出错时触发 
        },
        init: function (options) {
            if(!options) throw Error("BBManager.init: options.moduleName不能为空。");
            var userCallbacks = this.userCallbacks;
            this.moduleName = options.moduleName;
            for(var key in userCallbacks) {
                if(typeof options[key] === 'function') {
                    userCallbacks[key] = options[key];
                }
            }
            this.bindEvents();
        },
        bindEvents: function() {
            appCache.addEventListener("checking", this.cacheHandlers.checking, false);
            appCache.addEventListener("noupdate", this.cacheHandlers.noUpdate, false);
            appCache.addEventListener("downloading", this.cacheHandlers.downloading, false);
            appCache.addEventListener("progress", this.cacheHandlers.progress, false);
            appCache.addEventListener("error", this.cacheHandlers.error, false);
            appCache.addEventListener("updateready", this.cacheHandlers.updateReady, false);
            appCache.addEventListener("obsolete", this.cacheHandlers.obsolete, false);
            appCache.addEventListener("cached", this.cacheHandlers.cached, false);
        },
        cacheHandlers: {
            checking: function(e) {
                BBVersionManager.userCallbacks.onCheck();
            },
            noUpdate: function(e) {
                BBVersionManager.userCallbacks.onNoUpdate();
            },
            downloading: function(e) {
                BBVersionManager.userCallbacks.onUpdate();
            },
            progress: function(e) {
                var percent = (e.loaded/e.total) * 100,
                    info = {
                        loaded: e.loaded,
                        total: e.total
                    };
                if(!isNaN(percent)) {
                    info.percent = percent;
                } else {
                    info.percent = -1;
                }
                BBVersionManager.userCallbacks.onProgress(info);
            },
            updateReady: function(e) {
                BBVersionManager.userCallbacks.onUpdateOk();
            },
            obsolete: function(e) {
                //当缓存的资源因服务器操作失误而被删除时 
                //callNative("toldNativeCacheRemoved", BBVersionManager.moduleName);
                BBVersionManager.userCallbacks.onRemove();
            },
            cached: function(e) {
                callNative("toldNativeAppCached", BBVersionManager.moduleName, BBVersionManager.toldNativeAppCachedOK);
            },
            error:function(e) {
                BBVersionManager.userCallbacks.onError(e);
            }
        },
        toldNativeAppCachedOK: function() {
            BBVersionManager.userCallbacks.onFirstCached();
            try{
                appCache.update();
            } catch (e){}
        }
    }
}(window.applicationCache));