/**
 * Created with JetBrains WebStorm.
 * User: EX-LUOYONG002
 * Date: 13-12-10
 * Time: 上午10:04
 * To change this template use File | Settings | File Templates.
 */

;(function(){

    window.App = {};
    /**
     * 常量定义
     */
    App.IS_DEBUG=false;
    var ua = navigator.userAgent.toUpperCase();
    // 当前环境是否为Android平台
    App.IS_ANDROID = ua.indexOf('ANDROID') != -1;
    // 当前环境是否为IOS平台
    App.IS_IOS = ua.indexOf('IPHONE OS') != -1;
    // 当前环境是否为本地Native环境
    App.IS_NATIVE = (App.IS_ANDROID || App.IS_IOS) ? true : false;
    //判断当前环境是否为天下通
    App.IS_TXT = ua.indexOf("PATXT") != -1;
    //媒体来源于iphone的填IPHONE
    //stz 修正从手机的浏览器而来的情况：(也算是从浏览器而不是native而来)
    if(App.IS_DEBUG) App.IS_NATIVE = false;

    //=======================请求URL 相关================================
    // 服务器地址
    App.ServerHost = '';
    App.Environment = 'stg'; // 强制使用某个环境(测试用),默认就设置为空
    var host = location.hostname;
    // 请求对应URL对象化集合。
    var webServiceUrls = {
        // 会员登陆验证
        isLogin             : 'validateUMinfo.do' //登陆接口
    }

    if(App.Environment == 'stg'){  //测试环境
        App.ServerHost = '';
    }else if(App.Environment == 'prd'){ //生产环境
        App.ServerHost = '';
    }else if(App.Environment == 'int'){  // 开发环境
        App.ServerHost = '';
    }else{ // 本地虚拟数据环境
        App.ServerHost = '';
    }

    //获取对应的url
    App.getWebServiceUrl = function(name) {
        return App.ServerHost + webServiceUrls[name];
    }

    //=======================公共函数 相关================================

    //设置或获取document。cookie值:
    App.Cookie = Cookie = function(key, value, options) {
        if(arguments.length > 1 && (!/Object/.test(Object.prototype.toString.call(value)) || value === null || value === undefined)) {
            options = options || {};

            if(value === null || value === undefined) {
                options.expires = -1;
            }

            if( typeof options.expires === 'number') {
                var days = options.expires, t = options.expires = new Date();
                t.setDate(t.getDate() + days);
            }
            value = String(value);

            return (document.cookie = [encodeURIComponent(key), '=', options.raw ? value : encodeURIComponent(value), options.expires ? '; expires=' + options.expires.toUTCString() : '', options.path ? '; path=' + options.path : '', options.domain ? '; domain=' + options.domain : '', options.secure ? '; secure' : ''].join(''));
        }
        options = value || {};
        var decode = options.raw ? function(s) {
            return s;
        } : decodeURIComponent;
        var pairs = document.cookie.split('; ');
        for(var i = 0, pair; pair = pairs[i] && pairs[i].split('='); i++) {
            if(decode(pair[0]) === key)
                return decode(pair[1] || '');
        }
        return null;
    }

    /**
     * 获取URL参数
     * @param {String} name 参数名称
     */
    window.getParams = function(name) {
        var reg = new RegExp('(^|&)' + name + '=([^&]*)(&|$)', 'i');
        var r = window.location.search.substr(1).match(reg);
        if(r) {
            return decodeURI(r[2]);
        }
        return null;
    }

    //=======================Native 相关================================

    var callindex = 0, toString = Object.prototype.toString;
    /**
     * 调用一个Native方法
     * @param {String} name 方法名称
     */
    App.call = function(name) {
        // 获取传递给Native方法的参数
        var args = Array.prototype.slice.call(arguments, 1);
        var callback = '', item = null;

        // 遍历参数
        for(var i = 0, len = args.length; i < len; i++) {
            item = args[i];
            if(typeof item == "undefined") {
                item = '';
            }

            // 如果参数是一个Function类型, 则将Function存储到window对象, 并将函数名传递给Native
            if(toString.call(item) == '[object Function]') {
                callindex++;
                callback = name + 'Callback' + callindex;

                window[callback] = (function (item) {
                    return function () {
                        item.apply(this, arguments);
                        delete window[callback];
                    }
                })(item);
                item = callback;
            }
            args[i] = item;
        }

        if(App.IS_ANDROID) {// Android平台
            //android native没有写这个方法,但在2.3系统中会掉用到另外一同名方法,导致崩溃,所以跳过
            try {
                for(var i = 0, len = args.length; i < len; i++) {
                    // args[i] = '"' + args[i] + '"';
                    args[i] = '\'' + args[i] + '\'';
                }
                eval('window.android.' + name + '(' + args.join(',') + ')');
            } catch(e) {
                console.log(e)
            }
        } else if(App.IS_IOS) {// IOS平台
            if(args.length) {
                args = '|' + args.join('|');
            }
            // IOS通过location.href调用Native方法, _call变量存储一个随机数确保每次调用时URL不一致
            callindex++;
            //location.href = '#ios:' + name + args + '|' + callindex;
            try{
                var iframe = document.createElement("iframe");
                iframe.src = '#ios:' + name + args + '|' + callindex;
                iframe.style.display = "none";
                document.body.appendChild(iframe);
                iframe.parentNode.removeChild(iframe);
                iframe= null;
            }catch(e){
                location.href = '#ios:' + name + args + '|' + callindex;
            }
        }
    };


    //获取当前用户JID
    //callback: 返回的数据格式是字符串
    // 获取失败：{"result":"No","error":"获取JID失败！"}
    // 获取成功：{"result":"Yes", "jid":"ABCDEFG12345HIJKLMN0987" "error":""}
    App.getCurrentUserJID = function(callback) {
        if(App.IS_NATIVE){
            App.call('getCurrentUserJID',callback);
        }else{
            //虚拟返回JID
            var rs = '{"result":"Yes", "jid":"12345678", "error":""}';
            callback(rs);
        }
    }

    //获取当前用户手机号
    //callback: 返回的数据格式是字符串
    // 获取失败：{"result":"No","error":"获取手机号失败！"}
    // 获取成功：{"result":"Yes", "mobile":"15817343910" "error":""}
    App.getCurrentUserMobile = function(callback){
        if(App.IS_NATIVE){
            App.call('getCurrentUserMobile', callback);
        }else{
            //虚拟返回手机号
            var rs = '{"result":"Yes", "mobile":"15817343910", "error":""}';
            callback(rs);
        }
    }
    App.getMapDetail = function(lat,lng,addr){
        if(App.IS_NATIVE){
            App.call('getMapDetail',lat,lng,addr);
            console.log("calling getMapDetail")
        }else{
            //虚拟经纬度
            var rs = '{"lat":"222", "lng":"3333"}';
        }
        console.log("getMapDetail lat:"+lat+" lng:"+lng+" addr:"+addr );
    }
    App.backnative=function(){
        if(App.IS_NATIVE){
            App.call('backnative');
        }else{
            console.log("backnative") ;
        }

    }
    App.gotoPublic=function(jid){
        if(App.IS_NATIVE){
            App.call('gotoPublic',jid);
        }else{
            console.log("gotoPublic") ;
        }
    }
    App.loadUrl =function(url){
        if(App.IS_NATIVE){
            App.call('loadUrl',url);
        }else{
        	console.log("loadUrl");
        }
    }
    App.getConfig = function(callback){
        if(App.IS_NATIVE){
            App.call('getConfig', callback);
        }else{
            //虚拟返回手机号
            var rs = '{"CONFIG_TAG":"prd"}';
            callback(rs);
        }
    }
    App.alert=function(info){
        if(App.IS_NATIVE){
            App.call('alert', info);
        }else{
            alert(info);
        }
    }
    App.setTitle = function(text){
        if(App.IS_NATIVE){
            App.call('setTitle', text);
        }else{
            //alert(info);
        }
    }
    App.getStartPage=function(callback){
        if(App.IS_NATIVE){
            App.call('getStartPage', callback);
        }else{
            callback('{"lat":22.5631245,"lon":114.0904636,"page":10}');
            console.log('wait start code');
        }
    }
    App.talkingDataTrack=function(str){
        if(App.IS_NATIVE){
            App.call('talkingDataTrack', str);
        }else{
            console.log('talkingDataTrack:'+str);
        }
    }
    App.makeCall=function(telnum){
        if(App.IS_NATIVE){
            App.call('makeCall', telnum);
        }else{
            console.log('makeCall:'+telnum);
        }
    }
    App.jumpToPublicChat=function(){
        if(App.IS_NATIVE){
            App.call('jumpToPublicChat');
        }else{
            console.log('jumpToPublicChat');
        }
    }
    App.isOnLine=function(callback){
        if(App.IS_NATIVE){
            App.call('isOnLine',callback);
        }else{
            console.log('isOnLine');
            return true;
        }
    }

})();
